#ifndef _base_h
#define _base_h

//
// parameters for spherical Dirac-Program
//

//variables from ecapture.cc

extern double rhoYe;
extern double Ye;
extern double temp;
extern double tempMeV;
extern double lambda_e;
extern double Vs0;
extern double deltaQc;
extern double1(nufluxdisc);
extern double1(Enufluxdisc);
extern int nubins;
extern int ecrate_cal;
extern int countflux;
extern double1(fluxstore);


extern fstream nufluxfile;

// variables from pair.cc

extern int2(iph); 
extern int2(kpp);
extern double1(eph);
extern int npair;
extern int jphmax;
extern int2(iph_valid);
extern int npair_ph;
extern int npair_ah;
extern int lphmax;
//add for temperature
extern double2(umark);
extern double2(vmark);

// variables from rpa.cc

extern double2(arpa);
extern double2(brpa);
extern double2(xrpa);
extern double2(yrpa);
extern double2(arpas);
extern double2(brpas);
extern double1(erpa);
extern double1(erpas);
extern double2(rpa_full);
extern double2(xyrpa);
extern double1(c_erpa);
extern double1(c_erpas);
extern int ndim_o_c;
extern int ndim_o_r;

// Variables from incanon.cc

extern char nucnam[3];
extern char dummy[100];
extern int nama, nneu, npro;

extern int nhx, nb2x, nblock;

extern char txtfor[11];
extern double amsig, amome, amrho, amu;
extern double gsigs, gomes, grhos;
extern double a_s, b_s, c_s, d_s;
extern double a_v, b_v, c_v, d_v;
extern double a_tv;
extern double dsat;

extern char gogtxt[11];
extern double1(gogw);
extern double1(gogb);
extern double1(gogh);
extern double1(gogm);
extern double1(gogr);
extern double gogt3;
extern double gogwls;
extern double vfac;

extern double rmax;
extern double hmesh;
extern int nmesh;
extern double rmsn_2,rmsp_2,rms_2,rms_2_ch;

//coupling constants and their derivatives
extern double1(gsig);
extern double1(gome);
extern double1(grho);
extern double1(dgsig);
extern double1(dgome);
extern double1(dgrho);
extern double1(ddgsig);
extern double1(ddgome);
extern double1(ddgrho);
extern double1(denss);
extern double1(densv);
extern double1(denstv);
extern double2(coupl);
extern double2(dcoupl);
extern double2(ddcoupl);
extern double2(dens);
extern double1(sint);
extern double1(vint);
extern double1(tvint);

extern int1(ntpar);
extern int2(nr);	    
extern int2(nl);	    
extern int2(nj);
extern int2(kap);
extern int1(nf);
extern double3(wfg);
extern double3(dwfg);
extern double3(wfg_zero);
extern int ngh;
extern double2(ee);
extern double2(eeqp);
extern double2(de);
extern double2(vv);
extern double2(vo);
extern double2(uo);
extern int2(indinbl);
extern int2(iblock);
extern double3(h11);
extern double1(sigf);
extern double1(ala);
extern int ntmax;
extern double1(dens0);
extern double dens0_integ;

// Variables from paramet.cc
extern int j;
extern int parity;
extern double ediffmaxu;
extern double ediffmaxd;
extern int calc;
extern int xyprint; 
extern int lorchange;
extern double lorswidth;
extern double lorvwidth;
extern double hlorswidth;
extern double hlorvwidth;
extern int hartree;
extern int matprint;
extern int xyread;
extern int xyprobe;
extern int exccalc;
extern int transdens;
extern int transiso;
extern double transerg;
extern int tc_cur;
extern int tc_iso;
extern double tc_erg;
extern int calc_j;
extern int calc_parity;
extern double calc_ediffmaxu;
extern double calc_ediffmaxd;
extern int calc_calc;
extern int calc_xyprint; 
extern int calc_lorchange;
extern double calc_lorswidth;
extern double calc_lorvwidth;
extern double calc_hlorswidth;
extern double calc_hlorvwidth;
extern int calc_hartree;
extern int calc_matprint;
extern int calcfile_found;
extern double qptresh;
extern int respair;
extern double pairfac;
extern double deltafac;

// variables from relqrpa.cc  
extern int nmass;
extern int npot;
extern double1(rmass);
extern int lmax;
extern int nonlin;
extern double2(arpas);
extern double2(brpas);
extern int ljmax;
extern double gcoul;
extern double gpi,ampi;
extern int natural_parity;

// variables from qplevel.cc
extern double enpartmax;
extern double enpartmin;
extern double enholemax;
extern double enholemin;
extern int2(spur);

// variables from rpasort.cc
extern double2(erpa_im);
extern int im_count;

// variables from transcur.cc
extern double3(wfgdev);

extern fstream wffile, wgfile, dwffile, dwgfile;


// declarations of functions

extern void write_head(fstream &, int, int);
extern char lname (int);

extern double formfactor_fv(double);
extern double formfactor_fa(double);
extern double formfactor_muv(double);
extern double formfactor_fp(double);

double sign(double, double);
double fermi(int,int,double);
void cdgamma(double, double, double *, double *);
extern void ftchrpa(int,int,int);

extern void eccalc(int, double, double *);

extern void eccalc_nuflux(int, double, double *);

extern void phpair(int, int);

extern void field();

extern void incanon();

extern void mbout(double **, int, char *);

extern void mbout(double **, int, int, char *);

extern void mbin(double **, int, char *);

extern void mbin(double **, int, int, char *);

extern void vbin(double *, int, char *);

extern void vbout(double *, int, char *);

extern void rpa(int);

extern void qppairout(int, int, char *);

extern void paramet(char *);

extern void msym();

extern double fermi(int,int,double);

extern double mered_MJL_sigma(int, int, int, int, int,
                 int, int, int,
                 double,int);

extern double mered_MJL_nabla(int, int, int, int, int,
                 int, int, int,
                 double,int);

extern double mered_MJ_nabla_sigma(int, int, int, int, int,
                    int, int,
                    double,int);

extern double mered_MJ(int, int, int, int, int,
                int, int,
                double,int);

extern double mered_OMEGAJ(int, int, int, int, int,
                   int, int,
                   double,int);

extern double mered_DELTAJ(int,int, int, int, int,
                   int, int,
                   double,int);

extern double mered_DELTAJ_prime(int,int, int, int, int,
                   int, int,
                   double,int);

extern double mered_SIGMAJ(int,int, int, int, int,
                   int, int,
                   double,int);

extern double mered_SIGMAJ_prime(int,int, int, int, int,
                   int, int,
                   double,int);

extern double mered_SIGMAJ_twoprimes(int,int, int, int, int,
                   int, int,
                   double,int);

extern double sinrad(int, int, int, int, int, int, int, int, int);

extern double sinradjl(int, int, int, int, int, double, int, int,int,int);

extern void check();

extern int deriv(); // for derivatives of wfg

extern void qplevel();

extern void testint();

extern void lorneu(char *, char *, char *, char *);

extern void rpasort(int, double **, double **, double *, double *);

extern void rpaout(double **, double **, double *, int, int, char *);

extern void rpaprobe(int, double **, double **, double **, double **, 
		     double *);

extern void excstr(double *, double **, double **, int, int, 
		   char *, char *, char *, char *, char *, char *,
		   char *, char *, char *, char *, char *, 
		   double, double, int);

extern void mout(double **, int, int, char *, char *);

extern void prep();

extern void wfinter();

extern double fermi(int,int,double);

extern void cdgamma(double, double, double *, double *);

double sign(double, double);

extern double elred(int, int, int, int, int, int, int, int, int, int, int);

extern double magred(int, int, int, int, int, int, int,
                     int, int, int, int);

extern double monred(int, int, int, int, int, int, int, int, int, int);

extern double gtrred(int, int, int, int, int, int, int, int, int, int);

extern double sdrred(int, int, int, int, int, int, int, int, int, int, int);

extern double dipskalred(int, int, int, int, int, int, int, int, int, int);

extern double dipskalred1(int, int, int, int, int, int, int, int, int, int);


extern double diptoroidred(int, int, int, int, int, int, int, int, int, int);

extern double sinrad(int, int, int, int, int, int, int, int, int);

extern double fc_Coulomb(double);

extern double fermi_dirac_e(double, double);

#endif
