#include "common.h"
#include "base.h"
#include "sla.h"
#include "funk.h"
#include "mesh.h"
#include "prep.h"

static int lcal(int, int, int);

double deltapi(int pair1, int pair2)

{    
    int t1, t2, t3, t4;
    int st1,st2,st3,st4;
    int l1,l2,l3,l4,l1g,l2g,l3g,l4g;
    int j1,j2,j3,j4;
    int llow,l,ir;
    double sffff,sfgfg,sgfgf,sgggg;
    double deltapi_ret;
    double ang11,ang12,ang13,ang14,ang21,ang22,ang23,ang24;
    double fac;
    
    st1 = iph[pair1][1];
    st2 = iph[pair2][1];
    st3 = iph[pair1][2];
    st4 = iph[pair2][2];
	
    t1 = iph[pair1][3];
    t2 = iph[pair2][3];
    t3 = iph[pair1][4];
    t4 = iph[pair2][4];
    	
    l1 = nl[st1][t1];
    l2 = nl[st2][t2];
    l3 = nl[st3][t3];
    l4 = nl[st4][t4];    
	
    j1 = nj[st1][t1];
    j2 = nj[st2][t2];
    j3 = nj[st3][t3];
    j4 = nj[st4][t4];    

    l1g = lcal(l1,j1,2);
    l2g = lcal(l2,j2,2);
    l3g = lcal(l3,j3,2);
    l4g = lcal(l4,j4,2); 
    
    sffff = sfgfg = sgfgf = sgggg = 0.0;
    
    for(ir = 1; ir <= maxr; ir++)
    {
        sffff += wfg[st1][ir][t1]*wfg[st2][ir][t2]*
	           wfg[st3][ir][t3]*wfg[st4][ir][t4]*
		         pow(rmesh[ir],2.0)*rweight[ir];
        sfgfg += wfg[st1][ir][t1]*wfg[st2][ir+maxr][t2]*
	           wfg[st3][ir][t3]*wfg[st4][ir+maxr][t4]*
		         pow(rmesh[ir],2.0)*rweight[ir];
        sgfgf += wfg[st1][ir+maxr][t1]*wfg[st2][ir][t2]*
	           wfg[st3][ir+maxr][t3]*wfg[st4][ir][t4]*
		         pow(rmesh[ir],2.0)*rweight[ir];
        sgggg += wfg[st1][ir+maxr][t1]*wfg[st2][ir+maxr][t2]*
	           wfg[st3][ir+maxr][t3]*wfg[st4][ir+maxr][t4]*
		         pow(rmesh[ir],2.0)*rweight[ir];
    }	
    double deltasum = 0.0;     
    if(natural_parity == 1)
    {
        ang11 = syjj(j1,l1,j3,l3,j,j);
	ang12 = syjj(j2,l2,j4,l4,j,j);
	ang13 = syjj(j1,l1g,j3,l3g,j,j);
	ang14 = syjj(j2,l2g,j4,l4g,j,j);
        deltasum += sffff*ang11*ang12+sfgfg*ang11*ang14+
	            sgfgf*ang13*ang12+sgggg*ang13*ang14;	
    }
    else if(natural_parity == 0) 
    {
        if(j!=0)
        {
           ang11 = syjj(j1,l1,j3,l3,j-1,j);
	   ang12 = syjj(j2,l2,j4,l4,j-1,j); 
           ang13 = syjj(j1,l1g,j3,l3g,j-1,j);
	   ang14 = syjj(j2,l2g,j4,l4g,j-1,j);
        }
    
        ang21 = syjj(j1,l1,j3,l3,j+1,j);
        ang22 = syjj(j2,l2,j4,l4,j+1,j); 
        ang23 = syjj(j1,l1g,j3,l3g,j+1,j);
        ang24 = syjj(j2,l2g,j4,l4g,j+1,j);
       
        if(j!=0)
        {
           deltasum += sffff*ang11*ang12+sfgfg*ang11*ang14+
	            sgfgf*ang13*ang12+sgggg*ang13*ang14;
        }
        deltasum += sffff*ang21*ang22+sfgfg*ang21*ang24+
	            sgfgf*ang23*ang22+sgggg*ang23*ang24;
    }
    else
    {
        cout << "Error in natural_parity..." << endl;
	cout << "natural_parity = " << natural_parity << endl;
	exit(0);
    }
    fac = deltafac*hqc*pow(gpi,2.0)/(2*j+1);
    deltapi_ret = fac*deltasum;

    return deltapi_ret;
}     		    		    
         	
static int lcal(int lc, int jc, int bil)
{    
    if (bil == 1)
      return lc;
    
    else 
    {
	if (lc < jc)
	  return jc;
	else
	  return (lc-1);
    }
}    
      
       	 			 	   
