#include "common.h"
#include "base.h"
#include "sla.h"
#include "funk.h"
#include "edmonds.h"
#include "mesh.h"
#include "eigenval.h"
#include "prep.h"

double2(xrpa);
double2(yrpa);
double1(erpa);
double1(c_erpa);

int main ()
    { 
    double Eelectron, Eelstart, Eelmax, stepEel,Eelmid,Eelmid0,stepEel1,stepEel2,stepEel0;
    double ecsum;
    int nEelstart, nEelmax, nEelectron,nEelmid,nEelmid0;
    int imult, iparco, jtot, iparity,maxJ;
    int ntest=1;

    const double Gf=1.16639e-11;
//    const double TanCab = 0.25;
    const double TanCab = 0.2318;
    double thetaC,facto;

    thetaC = atan(TanCab);
    
    maxJ= 1;    
    Eelstart = 0.0;
    Eelmax = 30.0;
    Eelmid0 = 3.0;
    Eelmid = 10.0;
    stepEel0 = 0.1;
    stepEel1 = 0.5;
    stepEel2 = 2;
//    nEelmax = (int)((Eelmax - Eelstart)/stepEel);

    nEelmax = (int)((Eelmax-Eelmid)/stepEel2 + 
                     (Eelmid-Eelmid0)/stepEel1
                     +(Eelmid0-Eelstart)/stepEel0);    

    nEelmid = (int)( (Eelmid-Eelmid0)/stepEel1
                     +(Eelmid0-Eelstart)/stepEel0);
     
    nEelmid0 = (int)((Eelmid0-Eelstart)/stepEel0);

    double Ecrate[nEelmax];
   
// initialize
    for (nEelectron =0; nEelectron <= nEelmax; nEelectron++)
    { 
      Ecrate[nEelectron] = 0.0;
    }
 
    fstream crossfile;
 
    crossfile.open("ecapture.out",ios::out | ios::trunc);
    crossfile.setf(ios::scientific);
   
 
//  factor for capture rate  CHECK! --- [MeV^-1*cm]^2*1e-42
    facto = pow((Gf*cos(thetaC)*hqc*1e-13),2)*1e42;

    imult = 1;
    iparco = 1;    

    while (iparco <= 1)
    {
    jtot = imult;

    if ( iparco == 0)
       iparity = (imult+1)%2;
    else
       iparity = imult%2;

    imult ++;
    
    if ( (iparco == 0) && (imult == maxJ+1))
    {
      imult = 0;
      iparco = 1;
    }
    
    if ( (iparco == 1) && (imult == maxJ+1))
       iparco = 2;
    
    cout<< " jtot = "<< jtot << " iparity = " << iparity << endl;    

    ftchrpa(jtot,iparity);

    Eelectron = Eelstart;

    for ( nEelectron=0; nEelectron < nEelmax; nEelectron++)
    {
     ecsum = 0.0;
     if ( nEelectron < nEelmid0)
      stepEel = stepEel0;
     else if ( (nEelectron < nEelmid) && (nEelectron >= nEelmid0))
      stepEel = stepEel1; 
     else  
      stepEel = stepEel2;

     Eelectron = Eelectron + stepEel;
    
     eccalc(jtot,Eelectron, &ecsum);

     Ecrate[nEelectron] += ecsum*facto;
//     cout << " facto = " << facto <<" ecsum = " << ecsum << endl; 
//     cout << " Ecrate[nEelectron]= " << Ecrate[nEelectron] <<endl; 
    } 
    }

    Eelectron = Eelstart;

    for (nEelectron =0; nEelectron < nEelmax; nEelectron++)
    { 
     if ( nEelectron < nEelmid0)
      stepEel = stepEel0;
     else if ( nEelectron < nEelmid && nEelectron >= nEelmid0)     
      stepEel = stepEel1; 
     else
      stepEel = stepEel2;

     Eelectron = Eelectron + stepEel;

     crossfile<< Eelectron << "\t" << Ecrate[nEelectron] << endl; 
     
    }   

    return 0; 
    }
