#include "common.h"
#include "base.h"
#include "sla.h"
#include "funk.h"
#include "edmonds.h"
#include "mesh.h"
#include "eigenval.h"
#include "prep.h"

double2(xrpa);
double2(yrpa);
double1(erpa);
double1(c_erpa);

double rhoYe,temp,lambda_e;

int main ()
    { 
    double Eelectron, Eelstart, Eelmax, stepEel,Eelmid,Eelmid0,stepEel1,stepEel2,stepEel0;
    double ecsum;
    int nEelstart, nEelmax, nEelectron,nEelmid,nEelmid0;
    int imult, iparco, jtot, iparity,maxJ;
    int ntest=1;
    int i; 
    double rhoYeT[12][2]={{1e3,1.0},{1e3,3.0},{1e3,10.0},{1e3,100.0},{1e7,1.0},{1e7,3.0},
    {1e7,10.0},{1e7,100.0},{1e11,1.0},{1e11,3.0},{1e11,10.0},{1e11,100.0}}; 
    double rate_lambda[8];
   
    const double Gf=1.16639e-11;
//    const double TanCab = 0.25;
    const double TanCab = 0.2318;
    double thetaC,facto;

    int ecrate_cal=1;
    double rate=0;

    double ecrate(int);
    double rtsec(double,double,double,double,double);

    thetaC = atan(TanCab);
    maxJ= 1;    
    rhoYe = 1000;
    temp = 1;    

    if (ecrate_cal == 0 || ecrate_cal == 3)
    {
    Eelstart = 0.0;
    Eelmax = 30.0;
    Eelmid0 = 3.0;
    Eelmid = 10.0;
    stepEel0 = 0.1;
    stepEel1 = 0.5;
    stepEel2 = 2;
//    nEelmax = (int)((Eelmax - Eelstart)/stepEel);

    nEelmax = (int)((Eelmax-Eelmid)/stepEel2 + 
                     (Eelmid-Eelmid0)/stepEel1
                     +(Eelmid0-Eelstart)/stepEel0);    

    nEelmid = (int)( (Eelmid-Eelmid0)/stepEel1
                     +(Eelmid0-Eelstart)/stepEel0);
     
    nEelmid0 = (int)((Eelmid0-Eelstart)/stepEel0);

    double Eccross[nEelmax];
   
// initialize
    for (nEelectron =0; nEelectron <= nEelmax; nEelectron++)
    { 
      Eccross[nEelectron] = 0.0;
    }
 
    fstream crossfile;
 
    crossfile.open("ecapture.out",ios::out | ios::trunc);
    crossfile.setf(ios::scientific);
 
//  factor for capture rate  CHECK! --- [MeV^-1*cm]^2*1e-42
    facto = pow((Gf*cos(thetaC)*hqc*1e-13),2)*1e42;

    imult = 1;
    iparco = 1;    

    while (iparco <= 1)
    {
    jtot = imult;

    if ( iparco == 0)
       iparity = (imult+1)%2;
    else
       iparity = imult%2;

    imult ++;
    
    if ( (iparco == 0) && (imult == maxJ+1))
    {
      imult = 0;
      iparco = 1;
    }
    
    if ( (iparco == 1) && (imult == maxJ+1))
       iparco = 2;
    
    cout<< " jtot = "<< jtot << " iparity = " << iparity << endl;    

    ftchrpa(jtot,iparity);

    Eelectron = Eelstart;

    for ( nEelectron=0; nEelectron < nEelmax; nEelectron++)
    {
     ecsum = 0.0;
     if ( nEelectron < nEelmid0)
      stepEel = stepEel0;
     else if ( (nEelectron < nEelmid) && (nEelectron >= nEelmid0))
      stepEel = stepEel1; 
     else  
      stepEel = stepEel2;

     Eelectron = Eelectron + stepEel;
    
     eccalc(jtot,Eelectron, &ecsum);

     Eccross[nEelectron] += ecsum*facto;
//     cout << " facto = " << facto <<" ecsum = " << ecsum << endl; 
//     cout << " Eccross[nEelectron]= " << Eccross[nEelectron] <<endl; 
    } 
    }

    Eelectron = Eelstart;

    for (nEelectron =0; nEelectron < nEelmax; nEelectron++)
    { 
     if ( nEelectron < nEelmid0)
      stepEel = stepEel0;
     else if ( nEelectron < nEelmid && nEelectron >= nEelmid0)     
      stepEel = stepEel1; 
     else
      stepEel = stepEel2;

     Eelectron = Eelectron + stepEel;

     crossfile<< Eelectron << "\t" << Eccross[nEelectron] << endl; 
     
    }   

 } //if ecrate_cal

    if (ecrate_cal == 1 || ecrate_cal == 3) 
    {
     fstream ratemufile;

     ratemufile.open("ecrate_mu.out",ios::out | ios::trunc);
     ratemufile.setf(ios::scientific);


//      for (i=0;i<=11;i++)
     {
//      rhoYe = rhoYeT[i][0];
//      temp = rhoYeT[i][1];
//       rhoYe = 1e10;
//        rhoYe = 5.86*0.47*1e7;
       temp = 1.0/Boltzman/1e9;
//       temp = 2;
//      lambda_e = rtsec(20,40,1e-5,rhoYe,temp);
      lambda_e = 0;
        cout << "lambda_e = " << lambda_e << endl;
      for (i=0;i<=7;i++)
      {
       rate=ecrate(maxJ);
       cout << "rate = "<< rate << endl;
       rate=log(rate)/log(10);
       lambda_e=lambda_e+1;
       ratemufile << lambda_e-1 << "\t" << rate << endl;
      } 
      cout << rhoYe <<" " << temp <<" " << rate << endl; 
     }
   }   
 
    return 0; 
    }
