#include "common.h"
#include "base.h"
#include "sla.h"
#include "funk.h"
#include "edmonds.h"
#include "mesh.h"
#include "eigenval.h"
#include "prep.h"

double2(xrpa);
double2(yrpa);
double1(erpa);
double1(c_erpa);

int main ()
    { 
    double Eelectron, Eelstart, Eelmax, stepEel;
    double ecsum;
    int nEelstart, nEelmax, nEelectron;
    int imult, iparco, jtot, iparity,maxJ;
    int ntest=1;

    const double Gf=1.16639e-11;
//    const double TanCab = 0.25;
    const double TanCab = 0.2318;
    double thetaC,facto;

    thetaC = atan(TanCab);
    
    maxJ= 1;    
    Eelstart = 0.0;
    Eelmax = 30.0;
    stepEel = 2;
    nEelmax = (int)((Eelmax - Eelstart)/stepEel);

    double Ecrate[nEelmax];
   
// initialize
    for (nEelectron =0; nEelectron <= nEelmax; nEelectron++)
    { 
      Ecrate[nEelectron] = 0.0;
    }
 
    fstream crossfile;
 
    crossfile.open("ecapture.out",ios::out | ios::trunc);
    crossfile.setf(ios::scientific);
   
 
//  factor for capture rate  CHECK! --- [MeV^-1*cm]^2*1e-42
    facto = pow((Gf*cos(thetaC)*hqc*1e-13),2)*1e42;

    imult = 1;
    iparco = 1;    

    while (iparco <= 1)
    {
    jtot = imult;

    if ( iparco == 0)
       iparity = (imult+1)%2;
    else
       iparity = imult%2;

    imult ++;
    
    if ( (iparco == 0) && (imult == maxJ+1))
    {
      imult = 0;
      iparco = 1;
    }
    
    if ( (iparco == 1) && (imult == maxJ+1))
       iparco = 2;
    
    cout<< " jtot = "<< jtot << " iparity = " << iparity << endl;    

    ftchrpa(jtot,iparity);


    for ( nEelectron=0; nEelectron <= nEelmax; nEelectron++)
    {
     ecsum = 0.0;
 
     Eelectron = Eelstart + nEelectron*stepEel;
    
     eccalc(jtot,Eelectron, &ecsum);

     Ecrate[nEelectron] += ecsum*facto;
//     cout << " facto = " << facto <<" ecsum = " << ecsum << endl; 
//     cout << " Ecrate[nEelectron]= " << Ecrate[nEelectron] <<endl; 
    } 
    }

    for (nEelectron =0; nEelectron <= nEelmax; nEelectron++)
    { 
     Eelectron = Eelstart + nEelectron*stepEel;

     crossfile<< Eelectron << "\t" << Ecrate[nEelectron] << endl; 
     
    }   

    return 0; 
    }
