#include "common.h"
#include "base.h"
#include "sla.h"
#include "funk.h"
#include "edmonds.h"
#include "mesh.h"
#include "prep.h"
#define EPS 3.0e-11 /* EPS is the relative precision for gauss integration. */

// FOR CALCULATION OF NEUTRINO FLUXES IN ELECTRON CAPTURE


static int lcal(int, int, int);
/*
static void write_head(fstream &, int, int);
static char lname (int);

static double formfactor_fv(double);
static double formfactor_fa(double);
static double formfactor_muv(double);
static double formfactor_fp(double);

double sign(double, double);
double fermi(int,int,double);
void cdgamma(double, double, double *, double *);
*/

//   int j;
// int parity;
// double E_electron;
// double ampi=138.0;
// double amu=939.0;


void eccalc_nuflux(int jtot, double E_neutrino, double *ectotal)
{
    double1(charge);
    double1init(charge, ndim_o_c);
    double E_electron;
    

    j = jtot;
//    E_electron = Eelect;

//    cout << "J in eccalc = " << j << endl;
//    cout << "E_electron in eccalc = " << E_electron << endl;

    int pairc;
    int energyc;

    int st1, l1, j1;
    int st2, l2, j2;
    int l1g, l2g;    
    int iso,iso1,iso2;
    int i;
    
    fstream densfile;
    fstream qtransfile;

    int nl1, nl2;
    double sum, xwidth, xl;
    double prodens, neudens;
    
    double xy_norm,xy_norm1;
    double sum_test;
    double sum_out;
    int energy_cal;
    double sum_xx, sum_yy;
    double sum_out_proton, sum_out_neutron;
    double energy_peak;
    double beta_q;
    double nu_q;
    double calcterm;

    double v1,v2,u1,u2;
    
    int energy_start;
    
    energy_start = 1;
    
    int erp_ok;
        
    int erp_ok_1;

    xy_norm = 0.0;
    sum_xx=0.0;
    sum_yy=0.0;
    sum_out_proton=0.0;
    sum_out_neutron=0.0;
    // change this value for displaying higher energies
    const double exc_erg_max = 100.0;

    double Vc0;
    double Qvalue;
    int l_fromY;
    int lp_fromY;
    int k_simps;
    register int n_simps;
    register double fact_simps;
    register double step_simps;

    const double delnH = 0.78227;
    const double delnP = 1.294;
 
    double peR;
    
//    register double E_neutrino;
    
    register double term_cs_fermi = 0.0;
    register double term_cs_ema = 0.0;
    int necount = 1; 
    int imultip_cs;
    register double sumstrengthm_ML;
    register double strengthm2_ML;

    register double costheta;
    register double cos2theta_half;
    register double sin2theta_half;

    register double E_lepton;
    register double E_lepton_eff;
    register double p_lepton;
    register double p_electron;
    register double p_neutrino;
    register double p_lepton_eff;

    register double qtransfer2_time;
    register double qtransfer2_spat;
    register double qtransfer_time;
    register double qtransfer_spat;
    register double qtransfer_nu_2;
    register double ev_term;

    register double strengthm_MJ;
    register double strengthm_LJ;
    register double strength_MJ;
    register double strength_LJ;
    register double strength_LJ_MJ;
    register double strength_LJ5;
    register double strength_MJ5;
    
    register double strengthm_MJ5;
    register double strengthm_LJ5;
    register double strengthm_Jmag_tilde;
    register double strengthm_Jmag5;
    register double strengthm_Jelreal;
    register double strengthm_Jel_tilde5;
    register double strengthm_Jmag;
    register double strengthm_Jel;
    register double strengthm_JmagJel;

    register double angle_term1;
    register double angle_term2;
    register double angle_term3;
    register double angle_term_JmagJel;
    register double angle_term_LJ;
    register double angle_term_MJ;
    register double angle_term_LJ_MJ;
    
    register double trans_me1;
    register double trans_me2;
    register double trans_me3;
    register double term_ec, term_ec_factor;

    register double int_theta;
    register double ecapture_rateJ = zero;
    register double cross_section_ema = zero;
    register double cross_section_fermi = zero;
    register double cross_section_m_fermi = zero;
    double cross_section_m = zero;
    double cross_section_p = zero;
    
    double m_electron;
    double m_neutrino;
    double MT;
    int neutrino_type;
    double xyerror_cor;
    double xysum;
    int k;
    double p_electron_corr;

    int lt1, lt2;

    time_t tm3, tm4, tm5, tm6, tm7, tm8, tm9, tm10, tm11, tm12;

    int k_gauss;
    int n_gauss= 6;
    double x_theta[n_gauss], w_theta[n_gauss];
    void gauleg(double, double, double *, double *, int);   

    

/*
    cout << "-------------------------------------------" << endl;
    cout << "### testing transfer from init.cpp" << endl;
    cout << "...testing gfv..." << endl;
    cout << "... fak(4) = " << fak[4] << endl;
    cout << "... iv(2) = " << iv[2] << endl;
    cout << "... iv(3) = " << iv[3] << endl;
    cout << "...testing edmonds..." << endl;
    cout << "...wigner(1.5,0,1.0,0,0,0) = "
       << wigner(1.0,0,1.0,0,0,0) << endl;

    cout << "...racah(0.5,0.5,1, 6,5,5.5) = " << racah(0.5, 0.5, 1.0, 1.0, 0.0, 0.5) << endl;
    cout <<"...wigner(3,1,4,0,0,0) = " << wigner(3,1,4,0,0,0) << endl;
    cout << "### testing transfer from prep.cpp" << endl;
 
    cout << "rstep = " << rstep << endl;
    cout << "maxr = " << maxr << endl;
    cout << "-------------------------------------------" << endl;
*/
 
 // check this!
//    n_simps = 40;
//    step_simps = 2.0/n_simps;

//  change from simpson to gauss-lengendre
    gauleg(-1,1,x_theta,w_theta,n_gauss-1);     

 // electron neutrino
    neutrino_type = 0;
    m_electron = emass;
    m_neutrino = 2.2e-6;   

 //   cout << "emass = " << emass << endl;
 // muon neutrino
 // neutrino_type = 1;
 // m_lepton = mumass;
 // m_neutrino = 170.0e-3;

/*
    cout << "m_electron = " << m_electron << " m_neutrino = " << m_neutrino << endl;
    cout << "nama = " << nama << " npro = " << npro << endl;
*/
    MT = amu * nama;
//    cout << "amu = " << amu << " MT = "<< MT << endl;


/*
 // test calculations of rms radii

    double1(testsum);
    double1(testsump);
    double1init(testsum,maxr);
    double1init(testsump,maxr);
    int imesh;
    double rms_2_ch = 0.0;
    double dens0_integ;
   

    nama = (int) blecp1.anucl;
    npro = (int) blecp1.znucl;
    
    MT = amu * nama;
    
//    cout << "nama = " << nama << " npro = " << npro << endl;
//    cout << "amu = " << amu << " MT = " MT << endl;
 
//    cout << "... in neutcs A = " << blecp1.anucl << " " << nama << endl;
//    cout << "... in neutcs Z = " << blecp1.znucl << " " << npro << endl;
 
    densfile.open("dens0.out",ios::out | ios::trunc);

    qtransfile.open("qtransfer.out",ios::out | ios::in | ios::ate);

    densfile << "#ground-state-density for A = " << nama << " Z = " << npro
             << endl;

    for (imesh = 1; imesh <= maxr; imesh++)
     {
      testsum[imesh] = (blecp2.dp[imesh-1]+blecp2.dn[imesh-1])
                       *(pow(rmesh[imesh],2));

      densfile << rmesh[imesh] << "\t" << blecp2.dp[imesh-1]+blecp2.dn[imesh-1] << endl;
     }
    densfile.close();

    dens0_integ = simps(testsum,maxr,rstep)*4.0*pi;

//    cout << "dens0 integrated = "
//      << dens0_integ << endl;

    int istate;
    double rmsp_0 = 0.0;
    double rmsp_2 = 0.0;
    double rms_0 = 0.0;
    double rms_2 = 0.0;
    double normtest = 0.0;

    fstream testwave;
    

    // evaluate rms_0, rmsp_0

    for (istate = 0; istate <= bptl.nos-1; istate++)
    {
         l1 = bqwf.ll[istate];
           // here j's are enlarged by 1/2
         j1 = (bqwf.lj[istate]+1)/2;

     //   if(l1 == 0 && j1 == 1 && istate==0)
         {
          normtest = 0.0;
     //   cout << "istate = " << istate << endl;
          testwave.open("testwave.out",ios::out | ios::trunc);
          for(imesh = 1; imesh <= maxr; imesh++)
          {
           normtest += bwf.wf[istate][imesh-1]*bwf.wf[istate][imesh-1] * rweight[imesh];
     //    testwave << rmesh[imesh-1] << "\t" <<  bwf.dwf[istate][imesh-1] << endl; //rmesh[imesh-1] << endl;
          }
     //   cout << "normtest = " << normtest << endl;
          testwave.close();
     //   exit(0);
         }

         for (imesh = 1; imesh <= maxr; imesh++)
         {
          testsum[imesh] = bwf.wf[istate][imesh-1]*bwf.wf[istate][imesh-1];
          if(bqwf.lt[istate] == 1)
            testsump[imesh] = testsum[imesh];

         }
         rms_0 += simps(testsum,maxr,rstep)
              *(bqwf.lj[istate]+1.0)*occupa.focc[istate];
         if(bqwf.lt[istate] == 1)
          rmsp_0 += simps(testsump,maxr,rstep)
              *(bqwf.lj[istate]+1.0)*occupa.focc[istate];
    }

    // evaluate rms_2, rmsp_2

    for (istate = 0; istate <= bptl.nos-1; istate++)
    {
         for (imesh = 1; imesh <= maxr; imesh++)
         {
          testsum[imesh] = bwf.wf[istate][imesh-1]*bwf.wf[istate][imesh-1]
                          *pow(rmesh[imesh],2.0);
          if(bqwf.lt[istate] == 1)
            testsump[imesh] = testsum[imesh];

         }
         rms_2 += simps(testsum,maxr,rstep)
              *(bqwf.lj[istate]+1.0)*occupa.focc[istate];
         if(bqwf.lt[istate] == 1)
          rmsp_2 += simps(testsump,maxr,rstep)
              *(bqwf.lj[istate]+1.0)*occupa.focc[istate];
    }
  
    rms_2 /= rms_0; 
    rmsp_2 /= rmsp_0;
  
//    cout << "rms_0 = " << rms_0 << endl; 
//    cout << "rms_2 = " << rms_2 << endl;

//    cout << "sqrt(rms_2)= " << sqrt(rms_2) << endl;

//    cout << "rmsp_2  = " << rmsp_2 << endl;
//    cout << "sqrt(rmsp_2) = " << sqrt(rmsp_2) << endl;


    rms_2_ch = sqrt(rmsp_2 + 0.64);

// cout << "rms_2_ch = " << rms_2_ch << endl;

// check normalization of xy-eigenvectors
 

    for (i = 0; i <= bwu1.nconf-1; i++)
    {
        xysum = zero;

        for (k = 1; k <= bwu1.nconf-1; k++)
        xysum += bdiam.vecr[i][k]*bdiam.vecr[i][k]
                 - bdiam.vecr[i][k+bwu1.nconf]*bdiam.vecr[i][k+bwu1.nconf];

        xyerror_cor = 1.0/fabs(xysum);

        xyerror_cor = sqrt(fabs(xyerror_cor));

   //     cout << "xysum = " << xysum << " xyerror_cor = "
   //          << xyerror_cor << endl;

    }


  
    for (i = 0; i <= bwu1.nconf-1; i++)
    {
        xysum = zero;

        for (k = 1; k <= bwu1.nconf-1; k++)
          xysum += bdiam.vecr[i][k]*bdiam.vecr[i][k]
                 - bdiam.vecr[i][k+bwu1.nconf]*bdiam.vecr[i][k+bwu1.nconf];

        xyerror_cor = sqrt(1./abs0(xysum));

        cout << "xysum = " << xysum << " xyerror_cor = " 
             << xyerror_cor << endl;
       
          for (k = 1; k <= bwu1.nconf-1; k++)
          {
              bdiam.vecr[i][k] *= xyerror_cor;
              bdiam.vecr[i][k+bwu1.nconf] *= xyerror_cor;
          }
    }
   
*/

// cout << "### Calculating electron capture rate " << endl;
// cout << "Qvalue from interface = " << qval.qvalue << endl;
// cout << "Qvalue calculated = " << rpamix.xlamp - rpamix.xlamn -delnH << endl;
 
//   cout <<" delnH = " << delnH <<endl;
 
 for (energyc = 1; energyc <= ndim_o_c; energyc++)
 {
 
      tm3 = time(NULL);
//      cout << " energyc = " << energyc << " " << asctime(localtime(&tm3)) << endl;

// no imaginary states
        if (c_erpa[energyc] == zero)
          erp_ok = 1;
        else
          erp_ok = 0;
// normalization positive
        for ( pairc = 1; pairc <= npair; pairc++ )
        {        
        //   cout << "xrpa[" << pairc <<"] = " << xrpa[pairc][energyc] << " yrpa[" << pairc <<"] = " << yrpa[pairc][energyc] << endl;
   
           
          charge[energyc] += (xrpa[pairc][energyc]*xrpa[pairc][energyc] - yrpa[pairc][energyc]*yrpa[pairc][energyc])*abs0(vv[iph[pairc][1]][iph[pairc][3]] - vv[iph[pairc][2]][iph[pairc][4]]);

        }

//     cout <<"  ndim_o_c = " << ndim_o_c << "npair = " << npair << endl;
//     cout << "charge [" <<energyc <<"]" <<"  = " << charge[energyc] << endl;
//     cout << "erpa[" <<energyc <<"]" <<"  = " << erpa[energyc] << endl;

   if (charge[energyc] > 0.0 && abs0(erpa[energyc]) < 1000.0
         && erp_ok == 1 )
   {
//      cout <<"----------------------------"<< endl;
//      cout << "energyc = " << erpa[energyc] << endl;
//    energy conservation without explicit calculation of Q value
/*
      if(qval.qvalue < 1000.0)
         Qvalue = qval.qvalue;
      else
         Qvalue = rpamix.xlamp - rpamix.xlamn - delnH;
*/
//      cout << "Qvalue for EC = " << Qvalue << endl;

       Qvalue = ala[1] - ala[2]; // B_i - B_f, not experimental

//       Qvalue = 2.136;   // Ni56 experimental
//     Qvalue = -0.381;  // Ni58
//     Qvalue = -2.823;  // Ni60
//     Qvalue = -5.314;  // Ni62
//     Qvalue = -6.524;  // Ni64
//       Qvalue = -3.695;  // Fe56

//     E_neutrino = E_electron
//                  - erpa[energyc] + Qvalue;

//        E_neutrino = E_electron -erpa[energyc] - delnH; // YF.Niu
       
//       E_neutrino = E_electron -erpa[energyc] - delnP - deltaQc; // with screening      

       E_electron = E_neutrino + erpa[energyc] + delnP + deltaQc;

//     if(E_electron >= m_electron && E_neutrino >= m_neutrino  && 
//         erpa[energyc] >= 0.0 && erpa[energyc] <= E_electron+Qvalue)  

//       Qvalue = - Qvalue - delnH;  //change from experimental value to Bi-Bf

//       if(E_electron >= m_electron && E_neutrino >= m_neutrino && 
//           erpa[energyc] >= Qvalue)   //Bi-Bf
  
       if(E_electron >= m_electron && E_neutrino >= m_neutrino  )
     { 
       
//         cout << "E_neutrino = " << E_neutrino << " E_RPA = " << erpa[energyc] << endl;

       p_electron = sqrt(pow(E_electron,2)-pow(m_electron,2));
       if(E_electron > Vs0)
         p_electron_corr = sqrt(pow(E_electron-Vs0,2)-pow(m_electron,2));
       else
         p_electron_corr = p_electron; 

      
       p_neutrino = sqrt(pow(E_neutrino,2)-pow(m_neutrino,2));

       qtransfer2_time = pow(E_neutrino - E_electron,2);

    //   qtransfer_time = sqrt(qtransfer2_time);

// ???      qtransfer_time = E_lepton - E_neutrino;  

       qtransfer_time =  E_neutrino - E_electron;  // YF.Niu

       {

//       term_ec = pow(E_neutrino,2)/(1.0+E_neutrino/MT);

       term_ec = 0.0;
  
       int printmark =1;

       // integration over theta

       int_theta = 0.0;

//       for(k_simps = 0; k_simps <= n_simps; k_simps++)
         for(k_gauss =1; k_gauss <= n_gauss-1; k_gauss ++)
        {

         tm4 = time(NULL);
//         cout << " k_simps = " << k_simps << "  " << asctime(localtime(&tm4))<< endl;
 

//         costheta = -1.0 + k_simps *step_simps;     

         costheta = x_theta[k_gauss];

         term_ec_factor = pow(E_neutrino,2)/(1.0+E_electron/MT
                   *(1- p_electron*costheta/E_electron));
  
//         term_ec_factor = pow(E_neutrino,2);
            
         qtransfer2_spat = pow(p_electron,2) + pow(p_neutrino,2)
                       -2*p_electron*p_neutrino*costheta;

         qtransfer_spat = sqrt(qtransfer2_spat);

//         cout << "costheta1 = " << costheta << " qtransfer_spat1 = "
//              << qtransfer_spat << endl;


         qtransfer_nu_2 = qtransfer2_spat - qtransfer2_time;
//         cout <<" E_electron = " << E_electron <<" E_nu - E_e = " <<  E_neutrino - E_electron << endl;
//         cout <<" cos theta = " << costheta << endl;
//         cout << "qtransfer_nu_2 = " << qtransfer_nu_2 << endl;

      // transition matrix elements for Coulomb (M) and
      // longitudinal (L) multipole operators

         strengthm_MJ = 0.0;
         strengthm_LJ = 0.0; 
         strength_MJ = 0.0;
         strength_LJ = 0.0;
         strength_LJ_MJ = 0.0;
         
         strengthm_MJ5 = 0.0;
         strengthm_LJ5 = 0.0;
         strengthm_Jmag_tilde = 0.0;
         strengthm_Jmag5 = 0.0;
         strengthm_Jelreal = 0.0;
         strengthm_Jel_tilde5 = 0.0;
         

         if (qtransfer_nu_2 >= 0.0)
         { 
         for (pairc = 1; pairc <= npair; pairc++)
         {

                iso1 = iph[pairc][3];
                iso2 = iph[pairc][4];

//particle
                st1 = iph[pairc][1];
                l1 = nl[st1][iso1];
                j1 = nj[st1][iso1];
                l1g = lcal(l1,j1,2);

//hole
                st2 = iph[pairc][2];
                l2 = nl[st2][iso2];
                j2 = nj[st2][iso2];
                l2g = lcal(l2,j2,2);
/*
             if (l2 == 3 &&  j2 == 3 && nr[st2][iso2] == 1 && printmark == 0) 
             { 
               for (i =1; i<=maxr; i++)
                {
                  wffile<< rmesh[i]<<"  " << wfg[st2][i][2] << endl;
                  wgfile<< rmesh[i] << "  " << wfg[st2][i+maxr][2] << endl;
                }
               wffile << endl;
               wgfile << endl;
               for (i =1; i<=maxr; i++)                
                {
                  wffile<< rmesh[i]<<"  " << wfg[st2][i][2]*rmesh[i] << endl;
                  wgfile<< rmesh[i] << "  " << wfg[st2][i+maxr][2]*rmesh[i] << endl;
                }
                printmark = 1;

             } 
*/
   
//            ev_term = (xrpa[pairc][energyc]*vmark[pairc][1]*umark[pairc][2]
//                        + iv[j]*yrpa[pairc][energyc]*umark[pairc][1]*vmark[pairc][2])*abs0(vv[st1][iso1]-vv[st2][iso2]);

              ev_term = (xrpa[pairc][energyc]*vmark[pairc][1]*umark[pairc][2]
                        +yrpa[pairc][energyc]*umark[pairc][1]*vmark[pairc][2])
                         *abs0(vv[st1][iso1]-vv[st2][iso2]); //YF.Niu 2010.3.5.

//            if ( abs0(ev_term) > 0.8 )
//            cout << "pairc = " << pairc << " ev_term = " << ev_term << endl;
      
           // for EC only NP configurations:
 
           if (ev_term != 0.0)
           {

 /*           
     cout << " E_electron = " << E_electron << " p_electron = " << p_electron << endl;

       cout << " E_neutrino = " << E_neutrino << " p_neutrino = " << p_neutrino << endl;

       cout << " costheta = " << costheta << " qtransfer_spat = "
              << qtransfer_spat << endl << endl;

*/
           strengthm_MJ += ev_term * formfactor_fv(qtransfer_nu_2) 
                      * mered_MJ(st1,l1,j1,
                                st2,l2,j2,
                                j,qtransfer_spat,0);

          //  strengthm_MJ = 0.0;

//            cout << "strength_MJ = " << strengthm_MJ << endl;

           tm5 = time(NULL);
//           cout << " strengthm_MJ " << asctime(localtime(&tm5)) << endl;

           strengthm_LJ += ev_term * (qtransfer_time/qtransfer_spat)
                     * formfactor_fv(qtransfer_nu_2) 
                     * mered_MJ(st1,l1,j1,
                                st2,l2,j2,
                                j,qtransfer_spat,0);
         
//           cout << "strengthm_LJ = " << strengthm_LJ << endl;
           tm6 = time(NULL);
//          cout << " strengthm_LJ " << asctime(localtime(&tm6)) << endl;

         //   strengthm_LJ = 0.0;

           strengthm_MJ5 += (-1.0) * ev_term * (qtransfer_spat/MN)
                     * (formfactor_fa(qtransfer_nu_2)
                        * mered_OMEGAJ(st1,l1,j1,
                                st2,l2,j2,
                                j,qtransfer_spat,0)
                       + 0.5*(formfactor_fa(qtransfer_nu_2)
                          - m_electron*formfactor_fp(qtransfer_nu_2))
                            * mered_SIGMAJ_twoprimes(st1,l1,j1,
                                st2,l2,j2,
                                j,qtransfer_spat,0));  // YF.Niu + => -

      //       cout << "strengthm_MJ5 = " << strengthm_MJ5 << endl << endl;

           tm7 = time(NULL);
//           cout << " strengthm_MJ5 " << asctime(localtime(&tm7)) << endl;

           //  strengthm_MJ5 = 0.0;

          // adopted for electron capture:

           strengthm_LJ5 += ev_term 
                        // * (qtransfer_time/qtransfer_spat) YF.Niu
                        * formfactor_fa(qtransfer_nu_2)
                       * mered_SIGMAJ_twoprimes(st1,l1,j1,
                                st2,l2,j2,
                                j,qtransfer_spat,0);

/*
             cout <<"ev_term= " <<ev_term << " strengthm_LJ5 = " << strengthm_LJ5 << endl;         
             cout << " q0/qs= " << qtransfer_time/qtransfer_spat << endl;
             cout <<" FA = " <<formfactor_fa(qtransfer_nu_2) << endl;
             cout << " Sigma''= " <<mered_SIGMAJ_twoprimes(st1,l1,j1,
                                st2,l2,j2,
                                j,qtransfer_spat,1) << endl; 
*/
           tm8 = time(NULL);
//           cout << " strengthm_LJ5 " << asctime(localtime(&tm8)) << endl;

           // strengthm_LJ5 = 0.0;

           if(j >= 1)
           {
            strengthm_Jmag_tilde += (-1.0)*ev_term * (qtransfer_spat/MN)
                           * (formfactor_fv(qtransfer_nu_2)
                              * mered_DELTAJ(st1,l1,j1,
                                  st2,l2,j2,
                                  j,qtransfer_spat,0)
                               -0.5 * formfactor_muv(qtransfer_nu_2)
                                  * mered_SIGMAJ_prime(st1,l1,j1,
                                   st2,l2,j2,
                                   j,qtransfer_spat,0));

          //  strengthm_Jmag_tilde = 0.0;

           tm9 = time(NULL);
//           cout << " strengthm_Jmag_tilde " << asctime(localtime(&tm9)) << endl;

       //    cout << "strengthm_Jmag_tilde = " << strengthm_Jmag_tilde << endl;

            strengthm_Jmag5 += ev_term * formfactor_fa(qtransfer_nu_2)
                       * mered_SIGMAJ(st1,l1,j1,
                                st2,l2,j2,
                                j,qtransfer_spat,0);

          //  strengthm_Jmag5 = 0.0;
           tm10 = time(NULL);
//           cout << " strengthm_Jmag5 " << asctime(localtime(&tm10)) << endl;

         //   cout << "strengthm_Jmag5 = " << strengthm_Jmag5 << endl;
        
            strengthm_Jelreal += ev_term * (qtransfer_spat/MN)
                       * (formfactor_fv(qtransfer_nu_2)
                         * mered_DELTAJ_prime(st1,l1,j1,
                                st2,l2,j2,
                                j,qtransfer_spat,0)
                         + 0.5 * formfactor_muv(qtransfer_nu_2)
                                * mered_SIGMAJ(st1,l1,j1,
                                  st2,l2,j2,
                                  j,qtransfer_spat,0));
        
        
           // strengthm_Jelreal = 0.0;
           
           // cout << "strengthm_Jelreal = " << strengthm_Jelreal << endl;

          tm11 = time(NULL);
//           cout << " strengthm_Jelreal " << asctime(localtime(&tm11)) << endl;

            strengthm_Jel_tilde5 += ev_term 
                             * formfactor_fa(qtransfer_nu_2)
                             * mered_SIGMAJ_prime(st1,l1,j1,
                                st2,l2,j2,
                                j,qtransfer_spat,0);

           // strengthm_Jel_tilde5 = 0.0;

      //      cout << "strengthm_Jel_tilde5 = " << strengthm_Jel_tilde5 << endl;
           tm12 = time(NULL);
//           cout << " strengthm_Jel_tilde5 " << asctime(localtime(&tm12)) << endl;

           } // if j

          } // if ev_term
 
        } // pairc
     
        strength_LJ = pow(strengthm_LJ,2)+pow(strengthm_LJ5,2);
        
        strength_MJ = pow(strengthm_MJ,2)+pow(strengthm_MJ5,2);
       
        strength_LJ_MJ = 2.0*(strengthm_LJ*strengthm_MJ
                         + strengthm_LJ5*strengthm_MJ5);
/*        
          cout << "strength_LJ = " << strength_LJ << " strength_MJ = " << strength_MJ << endl; 
          cout << "strength_LJ_MJ = "  << strength_LJ_MJ << endl;
*/ 
        if(j >= 1)
        {
         strengthm_Jmag = pow(strengthm_Jmag_tilde,2)+pow(strengthm_Jmag5,2);

         strengthm_Jel = pow(strengthm_Jelreal,2)+pow(strengthm_Jel_tilde5,2);

         strengthm_JmagJel = 2.0*(strengthm_Jmag5*strengthm_Jelreal
                                +strengthm_Jmag_tilde*strengthm_Jel_tilde5);

        }

        else 
        {
         strengthm_Jmag = 0.0;
         strengthm_Jel = 0.0;
         strengthm_JmagJel = 0.0;
        }        
       
//       cout << " strengthm_Jmag = " << strengthm_Jmag << " strengthm_Jel = " << strengthm_Jel << " strengthm_JmagJel = " << strengthm_JmagJel << endl;
/*
        if(k_simps == 0 || k_simps == n_simps) fact_simps = 1.0/3.0;
        else
        {
         if(fmod((double)k_simps,2) == 0) fact_simps = 2.0/3.0;  //YF.Niu
         else fact_simps = 4.0/3.0;
        }
*/
        beta_q = (1.0/(qtransfer_spat*E_electron)) *
                 (p_electron*p_neutrino*costheta-pow(p_electron,2));

        nu_q = (p_neutrino-p_electron*costheta)/qtransfer_spat; 

        angle_term1 = 1.0-nu_q*beta_q;

        angle_term_JmagJel = -1.0*(nu_q-beta_q);

    //    angle_term_JmagJel = 0.0;

        angle_term_LJ = 1.0 - (p_electron*costheta)/E_electron
                       +2.0*nu_q*beta_q;

    //    angle_term_LJ = 0.0;
        
        angle_term_MJ = 1.0 + p_electron*costheta/E_electron;

    //    angle_term_MJ = 0.0;
        
        angle_term_LJ_MJ = -1.0*(nu_q+beta_q);

    //    angle_term_LJ_MJ = 0.0; 

//         calcterm = step_simps * fact_simps * 
//                     ( angle_term1 * (strengthm_Jmag + strengthm_Jel) 
//                       + angle_term_JmagJel * strengthm_JmagJel +
//                       angle_term_LJ * strength_LJ 
//                      + angle_term_MJ * strength_MJ +
//                       angle_term_LJ_MJ * strength_LJ_MJ);

//        calcterm = step_simps * fact_simps * term_ec_factor *
//                     ( angle_term1 * (strengthm_Jmag + strengthm_Jel)
//                       + angle_term_JmagJel * strengthm_JmagJel +
//                       angle_term_LJ * strength_LJ
//                      + angle_term_MJ * strength_MJ +
//                       angle_term_LJ_MJ * strength_LJ_MJ);

          calcterm = w_theta[k_gauss] * term_ec_factor *
                     ( angle_term1 * (strengthm_Jmag + strengthm_Jel)
                       + angle_term_JmagJel * strengthm_JmagJel +
                       angle_term_LJ * strength_LJ
                      + angle_term_MJ * strength_MJ +
                       angle_term_LJ_MJ * strength_LJ_MJ);


         int_theta += calcterm;
         
         if(calcterm > 0.0001) qtransfile << E_electron << "\t" << qtransfer_spat << endl;

/*           
         cout << "k_simps = " << k_simps << "step_simps = " << step_simps 
             << " fact_simps = " << fact_simps << endl;
         cout << " a1 = " << angle_term1 << " a2 = " << angle_term2
             << " a3 = " << angle_term3 << endl;
         cout << "a1*me1 = " << angle_term1 *trans_me1
              << " a2*me2 = " << angle_term2 * trans_me2
              << " a3*me3 = " << angle_term3 * trans_me3
              << endl;

         cout << "costheta = " << costheta << endl;

         cout << "qtransfer_nu_2 = " << qtransfer_nu_2 << endl;

         cout << " me1 = " << trans_me1 << " me2 = " << trans_me2
             << " me3 = " << trans_me3 << endl; 
	
         cout << "k_simps = " << k_simps << " int_theta = " 
              << int_theta << endl;	
   
         cout << "----------------------------------------------------" << endl;
*/     
  
          } //  if qtransfer_nu_2
        
         } // for k_simps

         // cout << "int_theta = " << int_theta << endl;

         // cout << "term_ec = " << term_ec << endl;

//         term_ec *= int_theta;
           
          term_ec = int_theta;  
       
       // correction with the Fermi function for the incoming electron
       // cout << "p_electron = " << p_electron << endl;

 
         term_ec *= fermi(npro,nama,p_electron_corr); // corrected for el. scr.

       //  cout << "term_ec with fermi = " << term_ec << endl;
         
         
         ecapture_rateJ += term_ec*pow(p_electron,2)*fermi_dirac_e(E_electron-Vs0,lambda_e);
/*
         if(term_ec > 1000.0)
         {
          cout << "E_neutrino = " << E_neutrino << " E_RPA = " << erpa[energyc] << endl;
          cout << "int_theta = " << int_theta << endl;
          cout << "term_ec final = " << term_ec << endl; 
          cout << "ecapture_rateJ = " << ecapture_rateJ << endl << endl;
         }
*/       
        } // if E_electroneff >= emass

       }// if E_electron >= emass
    
     } // if erpa
//          cout << "term_ec final = " << term_ec << endl;
//          cout << "ecapture_rateJ = " << ecapture_rateJ << endl << endl;

    } // for energyc 
        
    *ectotal = ecapture_rateJ;
    
//    cout << "end of eccalc ectotal = " << ecapture_rateJ << endl;

    qtransfile.close();

    double1del(charge); 

  } // excstr
//-----------------------------------------------------------------------
static int lcal(int lc, int jc, int bil)
{


    if (bil == 1)
      return lc;

    else
    {
        if (lc < jc)
          return jc;
        else
          return (lc-1);
    }
}

