#include "common.h"
#include "base.h"
#include "sla.h"
#include "funk.h"
#include "edmonds.h"
#include "mesh.h"
#include "prep.h"


double ecrate(int j,int iparity,int xyorder)
{
    double ec_rate,ec_rate1,ec_rate2,ec_rate3,factor,E1,E2,Emax;
    double Epeak;
    int ngauss2;

    const double Gf=1.16639e-11;
    const double TanCab = 0.2318;
    double thetaC;

    double ecrateint(double,double,int,int); 
    double searchpeak(double,int);
    
    time_t tmstart1,tmstop1;

//    tmstart1 = time(NULL);
//    cout << " ftchrpa start : " << asctime(localtime(&tmstart1)) << endl;

    
    Emax = lambda_e + 45*temp*Boltzman*1e9;

    thetaC = atan(TanCab);
    ec_rate =0 ;

    factor = pow(Gf*cos(thetaC),2)/(2*pow(pi,3))*2*pi*3/hqc*1e23; 

//  for (j=0; j<=maxJ; j++)
  {
//   for (iparity = 0; iparity = 1; iparity ++)
   {
//     j = 1;
//     iparity = 1;
     ftchrpa(j,iparity,xyorder);

//     tmstop1 = time (NULL);
//     cout << "ftchrpa stop : " << asctime(localtime(&tmstop1)) << endl;

     Epeak = searchpeak(Emax, j);
//     cout <<"peak = " << Epeak << endl;
     E1 = Epeak - 6*temp*Boltzman*1e9;
     if (E1 < emass)
     { E1 = emass; }
 
     E2 = Epeak + 6*temp*Boltzman*1e9;
//
     ngauss2 = int((E2-E1)/(0.1*temp*Boltzman*1e9))/10;

//      ngauss2 = int((E2-E1)/(0.1*temp*Boltzman*1e9));

//   reduced number of gauss points
 
     ec_rate1 = ecrateint(emass,E1,10,j);
     ec_rate2 = ecrateint(E1,E2,ngauss2,j); 
     ec_rate3 = ecrateint(E2,Emax,10,j);

     ec_rate = ec_rate + ec_rate1+ec_rate2+ec_rate3;

//     tmstop1 = time (NULL);
//     cout << "ecrate stop : " << asctime(localtime(&tmstop1)) << endl;

   } // for parity
  } // for j

   double2del(xrpa,npair);
   double2del(yrpa,npair);
   double1del(erpa);
   double1del(c_erpa);
    
     ec_rate = ec_rate*factor;
     return ec_rate;
}

double searchpeak(double Emax, int j)
{
 double Eleft, Eright, Emid, derivl,derivr,derivm;
 double ecfuncmid;
 double ecfunc(double, int);

 Eleft = emass;
 Eright = Emax;
 // cout << "Emax = "<< Eright<< endl;


  derivl = (ecfunc(Eleft+0.1,j)-ecfunc(Eleft,j))/0.1;
  derivr = (ecfunc(Eright,j)-ecfunc(Eright-0.1,j))/0.1;
 
 while( (Eright - Eleft) > 0.5)
 {
  if (derivr<=0 )
  {
   Emid = (Eleft+Eright)/2;
//   cout << "Emid= " << Emid << endl;
   ecfuncmid = ecfunc(Emid,j);
   derivm = (ecfunc(Emid+0.1,j)-ecfuncmid)/0.1;
   if ( derivm*derivr<= 0 ||  (derivm<0 && ecfuncmid < 1e-18) )
     { Eleft = Emid;
       derivl = derivm;
     }
   else
     { Eright = Emid; 
       derivr= derivm;
     }
//   cout <<" Eleft = " << Eleft << " " << Eright << endl;
  } //end if 
  else
  {
   return 0.0;
//   cout<<"wrong in peak search!" << endl;;
  } //end else
 } // end while
 
  return (Eleft+Eright)/2;
}

double ecrateint(double Emin, double Emax, int n_gauss,int j)
{
    int k_gauss;
    double ecfunctemp, ec_rate, Eelectron;
    double x_Eelectron[n_gauss], w_Eelectron[n_gauss];

     void gauleg(double, double, double *, double *, int);
     double ecfunc(double, int);

     ec_rate = 0;
     ecfunctemp = 0;

//     cout << "n_gauss = " << n_gauss << endl;
     gauleg(-1,1,x_Eelectron,w_Eelectron,n_gauss-1);

     for(k_gauss =1; k_gauss <= n_gauss-1; k_gauss ++)
     {
       Eelectron = (Emax-Emin)/2*x_Eelectron[k_gauss]+(Emax+Emin)/2;
    
       if(Eelectron > emass)
      {
       ecfunctemp = ecfunc(Eelectron,j);
       ec_rate += ecfunctemp
                  *w_Eelectron[k_gauss];
    //   cout<< Eelectron <<" " << ecfunctemp << endl;
       }
        else
        ec_rate = 0.0;

     } // for k_gauss
       return ec_rate*(Emax-Emin)/2;
}


double ecfunc(double E,int j)
{
  double p, occup, ecsum, ecfunction;

  time_t tmstart2,tmstop2;

// screening

  ecfunction = 0.0;
  if (E-Vs0 > emass)
  {
  p = sqrt((E-Vs0)*(E-Vs0)-emass*emass);

  occup = fermi_dirac_e(E-Vs0,lambda_e);

//  tmstart2 = time(NULL);
//    cout << " eccalc start : " << asctime(localtime(&tmstart2)) << endl;

  eccalc(j,E,&ecsum);

//    tmstop2 = time(NULL);
//    cout << " eccalc stop : " << asctime(localtime(&tmstop2)) << endl;


  ecfunction = p*(E-Vs0)*occup*ecsum;

  }

  return ecfunction;
}

