#include "common.h"
#include "base.h"
#include "sla.h"
#include "funk.h"
#include "edmonds.h"


static int lcal(int, int, int);
static void write_head(fstream &, int, int);
static char lname (int);

double sign(double, double);
double fermi(int,int,double);
void cdgamma(double x1, double x2, double *x3, double *x4);


void excstr(double *erpa, double **xrpa,
	    double **yrpa, int npair, int j, char *fileskal,
	    char *filevec, char *filecurv, char *fileneu, 
	    char *filepro, char *filetot, char *filelskal,
	    char *filelvec, char *filepskal, char *filepvec,
	    char *filestrength, double lswid, double lvwid,
	    int hp)
{

    int pairc;
    int energyc;

    int st1, l1, j1;
    int st2, l2, j2;
    int l1g, l2g;    
    int iso,iso1,iso2;
    int i;
    
    fstream skalfile;
       fstream vecfile;       
    fstream lorskalfile;
    fstream purskalfile;
    fstream strengthfile;
       fstream lorvecfile; 
    int nl1, nl2;
    double sum, xwidth, xl;
    double prodens, neudens;
    int1(energ);
    
    double iasstrengthp,iasstrengthm,iasstrengthsump,iasstrengthsumm;    
    double2(ias);
    double gtrstrengthp,gtrstrengthm,gtrstrengthsump,gtrstrengthsumm;    
    double2(gtr);  
    double sdrstrengthp,sdrstrengthm,sdrstrengthsump,sdrstrengthsumm;    
    double2(sdr);       
    
    double1(bmonvec);
    double1(belskal); 
    double1(belvec);
    double1(bmagskal);
    double1(bmagvec);
    double1(belp);
    double1(beln);
    double1(stre);    
    
    double1(charge);

    double2init(ias,ndim_o_c,2);
    double2init(gtr,ndim_o_c,2); 
    double2init(sdr,ndim_o_c,2);    
      
    double1init(bmonvec,ndim_o_c);
    double1init(belskal,ndim_o_c);
    double1init(belvec,ndim_o_c);
    double1init(belp,ndim_o_c);
    double1init(beln,ndim_o_c);
    double1init(bmagskal,ndim_o_c);
    double1init(bmagvec,ndim_o_c);
    double1init(stre,ndim_o_c);
    
    double1init(charge, ndim_o_c);    
    
    double neufact;
    double profact;

    double xy_norm,xy_norm1;
    double sum_test;
    double sum_out;
    int energy_cal;
    double sum_xx, sum_yy;
    double sum_out_proton, sum_out_neutron;
    double energy_peak;

    
    int1init(energ,ndim_o_c);
    
    int energy_start;
    
    
    energy_start = 1;
    
    int erp_ok;
        
    int erp_ok_1;
     
    xy_norm = 0.0;
    sum_xx=0.0;
    sum_yy=0.0;
    sum_out_proton=0.0;
    sum_out_neutron=0.0;
    // change this value for displaying higher energies
    const double exc_erg_max = 200.0;
    cout << "Maximal RPA energy : " << erpa[ndim_o_c] << endl;
   

    //PEAK FOR ANALYSIS IS WRITTEN IN START.DAT - transerg  
       energy_peak=transerg;       

    
    // for j=1 transition- isovector dipole-operator
    neufact = (double(npro))/(double(npro+nneu));
    profact = (double(nneu))/(double(npro+nneu));

    // searching for RPA-eigenvalue close to the energy_peak from input
  energy_cal = energy_start;

  for (energyc = energy_start; energyc <= ndim_o_c; energyc++)
  {
     if (abs0(erpa[energyc]-energy_peak) < 1.e-2)
     {
         cout << "energyc = " << erpa[energyc] << endl;
         energy_cal = energyc; 
         break;
     }
  }
  
  cout << "printing configurations for energy erpa=" << erpa[energy_cal] << endl; 


    // summing up excitations strengths for valid energies
    for (energyc = energy_start; energyc <= ndim_o_c; energyc++) 
    {
	

	// no imaginary states
	if (c_erpa[energyc] == zero)
	  erp_ok_1 = 1;
	else
	  erp_ok_1 = 0;
        
// normalization positive 
        for ( pairc = 1; pairc <= npair; pairc++ )     
        {
          charge[energyc] += xrpa[pairc][energyc]*xrpa[pairc][energyc] - yrpa[pairc][energyc]*yrpa[pairc][energyc]; 
          
        }	
//          cout << "charge[" << erpa[energyc] << " ]" << charge[energyc] << endl;
	if ( (charge[energyc] > 0.0 || erpa[energyc] < -1000.0) && (erp_ok_1 == 1))
	{	 	
	    iasstrengthsump = iasstrengthsumm = zero;
	    gtrstrengthsump = gtrstrengthsumm = zero;
	    sdrstrengthsump = sdrstrengthsumm = zero;	    	    

	    for (pairc = 1; pairc <= npair; pairc++) 
	    {   
		    
		iso1 = iph[pairc][3];
		iso2 = iph[pairc][4];
		    
//particle
		st1 = iph[pairc][1];
		l1 = nl[st1][iso1];		  
		j1 = nj[st1][iso1];
		l1g = lcal(l1,j1,2);
		  
//hole
		st2 = iph[pairc][2];
		l2 = nl[st2][iso2];
		j2 = nj[st2][iso2];
		l2g = lcal(l2,j2,2);
	 
//  NORMALIZATION OF X`s and Y`s
// 
       
                if (energyc == energy_cal)
                {
                 xy_norm+=(xrpa[pairc][energy_cal]*xrpa[pairc][energy_cal]-
                 yrpa[pairc][energy_cal]*yrpa[pairc][energy_cal])
                 *abs0(vv[st2][iso2]-vv[st1][iso1]);
                 xy_norm1=(xrpa[pairc][energy_cal]*xrpa[pairc][energy_cal]-
                 yrpa[pairc][energy_cal]*yrpa[pairc][energy_cal])
                 *abs0(vv[st2][iso2]-vv[st1][iso1]);
                 sum_xx+=xrpa[pairc][energy_cal]*xrpa[pairc][energy_cal]
                        *abs0(vv[st2][iso2]-vv[st1][iso1]);
                 sum_yy+=yrpa[pairc][energy_cal]*yrpa[pairc][energy_cal]
                        *abs0(vv[st2][iso2]-vv[st1][iso1]);
                } 
       
                if (j == 0 && natural_parity == 1)  //IAS
                {
                /*		
	             iasstrengthm=
		      (xrpa[pairc][energyc]*uo[st1][iso1]*vo[st2][iso2]+
	               yrpa[pairc][energyc]*vo[st1][iso1]*uo[st2][iso2])*
		      (monred(st1,l1,j1,iso1,1,st2,l2,j2,iso2,1)
                      +monred(st1,l1g,j1,iso1,2,st2,l2g,j2,iso2,2));
	              iasstrengthp=
		      -(xrpa[pairc][energyc]*vo[st1][iso1]*uo[st2][iso2]+
	               yrpa[pairc][energyc]*uo[st1][iso1]*vo[st2][iso2])*
		      (monred(st1,l1,j1,iso1,1,st2,l2,j2,iso2,1)
                      +monred(st1,l1g,j1,iso1,2,st2,l2g,j2,iso2,2));       
	        */
                     iasstrengthm=
                      (xrpa[pairc][energyc]*umark[pairc][1]*vmark[pairc][2]
                       + yrpa[pairc][energyc]*vmark[pairc][1]*umark[pairc][2])*
                      (monred(st1,l1,j1,iso1,1,st2,l2,j2,iso2,1)
                      +monred(st1,l1g,j1,iso1,2,st2,l2g,j2,iso2,2))
                      *abs0(vv[st2][iso2]- vv[st1][iso1]);
                     iasstrengthp=
                      -(xrpa[pairc][energyc]*vmark[pairc][1]*umark[pairc][2]
                      + yrpa[pairc][energyc]*umark[pairc][1]*vmark[pairc][2])*
                      (monred(st1,l1,j1,iso1,1,st2,l2,j2,iso2,1)
                      +monred(st1,l1g,j1,iso1,2,st2,l2g,j2,iso2,2))
                      *abs0(vv[st1][iso1]- vv[st2][iso2]);
                   //   cout<< "yrpa[" <<pairc<<"][" <<energyc << "]" << yrpa[pairc][energyc]*umark[pairc][1]*vmark[pairc][2]<<endl; 
                   
                   iasstrengthsumm += iasstrengthm;
	           iasstrengthsump += iasstrengthp;		   	      
                }
		else if( j==1 && natural_parity == 0 ) //GTR	  
		{/*
                   gtrstrengthm =
                      (xrpa[pairc][energyc]*uo[st1][iso1]*vo[st2][iso2]-
                       yrpa[pairc][energyc]*vo[st1][iso1]*uo[st2][iso2])*
                      (gtrred(st1,l1,j1,iso1,1,st2,l2,j2,iso2,1)
                      +gtrred(st1,l1g,j1,iso1,2,st2,l2g,j2,iso2,2));
                   gtrstrengthp =
                      (xrpa[pairc][energyc]*vo[st1][iso1]*uo[st2][iso2]-
                       yrpa[pairc][energyc]*uo[st1][iso1]*vo[st2][iso2])*
                      (gtrred(st1,l1,j1,iso1,1,st2,l2,j2,iso2,1)
                      +gtrred(st1,l1g,j1,iso1,2,st2,l2g,j2,iso2,2));
                 */
     /*		   gtrstrengthm =
                      (xrpa[pairc][energyc]*umark[pairc][1]*vmark[pairc][2]-
	               yrpa[pairc][energyc]*vmark[pairc][1]*umark[pairc][2])*
		      (gtrred(st1,l1,j1,iso1,1,st2,l2,j2,iso2,1)
                      +gtrred(st1,l1g,j1,iso1,2,st2,l2g,j2,iso2,2))
                      *abs0(vv[st2][iso2]- vv[st1][iso1]) ;
		   gtrstrengthp =
                      (xrpa[pairc][energyc]*vmark[pairc][1]*umark[pairc][2]-
	               yrpa[pairc][energyc]*umark[pairc][1]*vmark[pairc][2])*
		      (gtrred(st1,l1,j1,iso1,1,st2,l2,j2,iso2,1)
                      +gtrred(st1,l1g,j1,iso1,2,st2,l2g,j2,iso2,2))
                      *abs0(vv[st1][iso1]- vv[st2][iso2]) ;  
     */

                   gtrstrengthm =
                      (xrpa[pairc][energyc]*umark[pairc][1]*vmark[pairc][2]+
                       yrpa[pairc][energyc]*vmark[pairc][1]*umark[pairc][2])*
                      (gtrred(st1,l1,j1,iso1,1,st2,l2,j2,iso2,1)
                      +gtrred(st1,l1g,j1,iso1,2,st2,l2g,j2,iso2,2))
                      *abs0(vv[st2][iso2]- vv[st1][iso1]) ;
                   gtrstrengthp =
                      (xrpa[pairc][energyc]*vmark[pairc][1]*umark[pairc][2]+
                       yrpa[pairc][energyc]*umark[pairc][1]*vmark[pairc][2])*
                      (gtrred(st1,l1,j1,iso1,1,st2,l2,j2,iso2,1)
                      +gtrred(st1,l1g,j1,iso1,2,st2,l2g,j2,iso2,2))
                      *abs0(vv[st1][iso1]- vv[st2][iso2]) ;

                //   if(j2 == l2+1 && j1 == l1)
                   {    
	            gtrstrengthsumm += gtrstrengthm;
	            gtrstrengthsump += gtrstrengthp;
                   }		   
		} 
		else if( (j==1 && natural_parity == 1) ||
		         (j==0 && natural_parity == 0) ||
			 (j==2 && natural_parity == 0) ) //SDR	  
		{
/*		   sdrstrengthm =
                      (xrpa[pairc][energyc]*uo[st1][iso1]*vo[st2][iso2]
	            +iv[j]*yrpa[pairc][energyc]*vo[st1][iso1]*uo[st2][iso2])*
		      (sdrred(st1,l1,j1,iso1,1,st2,l2,j2,iso2,1,j)
                      +sdrred(st1,l1g,j1,iso1,2,st2,l2g,j2,iso2,2,j));
		   //   (dipskalred(st1,l1,j1,iso1,1,st2,l2,j2,iso2,1)
                   //   +dipskalred(st1,l1g,j1,iso1,2,st2,l2g,j2,iso2,2));	
		   sdrstrengthp =
                      (xrpa[pairc][energyc]*vo[st1][iso1]*uo[st2][iso2]
	            +iv[j]*yrpa[pairc][energyc]*uo[st1][iso1]*vo[st2][iso2])*
		      (sdrred(st1,l1,j1,iso1,1,st2,l2,j2,iso2,1,j)
                      +sdrred(st1,l1g,j1,iso1,2,st2,l2g,j2,iso2,2,j)); 
		   //   (dipskalred(st1,l1,j1,iso1,1,st2,l2,j2,iso2,1)
                   //   +dipskalred(st1,l1g,j1,iso1,2,st2,l2g,j2,iso2,2));
*/
                   sdrstrengthm =
                      (xrpa[pairc][energyc]*umark[pairc][1]*vmark[pairc][2]
                    +  yrpa[pairc][energyc]*vmark[pairc][1]*umark[pairc][2])*
                      (sdrred(st1,l1,j1,iso1,1,st2,l2,j2,iso2,1,j)
                      +sdrred(st1,l1g,j1,iso1,2,st2,l2g,j2,iso2,2,j))
                      *abs0(vv[st2][iso2]- vv[st1][iso1]);
                   sdrstrengthp =
                      (xrpa[pairc][energyc]*vmark[pairc][1]*umark[pairc][2]
                    +  yrpa[pairc][energyc]*umark[pairc][1]*vmark[pairc][2])*
                      (sdrred(st1,l1,j1,iso1,1,st2,l2,j2,iso2,1,j)
                      +sdrred(st1,l1g,j1,iso1,2,st2,l2g,j2,iso2,2,j))
                       *abs0(vv[st1][iso1]- vv[st2][iso2]);

	           sdrstrengthsumm += sdrstrengthm;
	           sdrstrengthsump += sdrstrengthp;		   
		} 		  				     	       
            }  //for(pairc)
				    	

	    if (j == 0 && natural_parity == 1) //IAS
	    {	   
		ias[energyc][1] =abs0((iasstrengthsumm)*(iasstrengthsumm));
		ias[energyc][2] =abs0((iasstrengthsump)*(iasstrengthsump));	
	    }	    
	    else if(j == 1 && natural_parity == 0)  //GTR
	    {
		gtr[energyc][1] =abs0((gtrstrengthsumm)*(gtrstrengthsumm));
		gtr[energyc][2] =abs0((gtrstrengthsump)*(gtrstrengthsump));	 
	    }
	    else if( (j == 1 && natural_parity == 1) ||
		         (j==0 && natural_parity == 0) ||
			 (j==2 && natural_parity == 0) ) //SDR		    
	    {
		sdr[energyc][1] =abs0((sdrstrengthsumm)*(sdrstrengthsumm));
		sdr[energyc][2] =abs0((sdrstrengthsump)*(sdrstrengthsump)); 
	    }	    
	    		    
	}
							
    }

    cout << "calculation of strengths finished" << endl;
    

    skalfile.open(fileskal, ios::out | ios::trunc);
    skalfile.setf(ios::scientific);
    write_head(skalfile,0,hp);

    vecfile.open(filevec, ios::out | ios::trunc);
    vecfile.setf(ios::scientific);
    write_head(vecfile,1,hp);
        
    lorskalfile.open(filelskal, ios::out | ios::trunc);
    lorskalfile.setf(ios::scientific);
    write_head(lorskalfile,0,hp);
    
    lorvecfile.open(filelvec, ios::out | ios::trunc);
    lorvecfile.setf(ios::scientific);
    write_head(lorvecfile,1,hp); 
       
    strengthfile.open(filestrength, ios::out | ios::trunc);
    strengthfile.setf(ios::scientific);
    write_head(strengthfile,-1,hp);

    strengthfile << "# 2qp contributions " << endl;
    if( energy_cal != energy_start)
    {
    cout << "ERPA = " << erpa[energy_cal] << endl;
    cout << "Sum XX = " << sum_xx << "    Sum YY = " << sum_yy ;
    cout << "     Sum XX-YY =" << xy_norm << "\n" << endl;
    sum_test=0.0;
    cout << " iso2 iso1       E/hole      E/particle  XX-YY/%" << endl;
    for(pairc=1; pairc <= npair; pairc++)
    {

    iso1 = iph[pairc][3];
    iso2 = iph[pairc][4];

    st2 = iph[pairc][2];

    st1 = iph[pairc][1];

    l1 = nl[st1][iso1];

    l2 = nl[st2][iso2];

    j1 = nj[st1][iso1];

    j2 = nj[st2][iso2];
/*
    sum_out =(100.0*(xrpa[pairc][energy_cal]*xrpa[pairc][energy_cal]
             -yrpa[pairc][energy_cal]*yrpa[pairc][energy_cal])/xy_norm);
*/
    sum_out =(100.0*(xrpa[pairc][energy_cal]*xrpa[pairc][energy_cal]
             -yrpa[pairc][energy_cal]*yrpa[pairc][energy_cal])
            *abs0(vv[st2][iso2]-vv[st1][iso1])/xy_norm);
 
   if (abs0(sum_out)> 0.01)
    {
    printf("%d %d  %10.5lf  ->  %10.5lf %d%c%d/2  -> %d%c%d/2   %12.8lf\n",
              iso2,iso1, ee[iph[pairc][2]][iso2],
              ee[iph[pairc][1]][iso1],
              nr[iph[pairc][2]][iso2],lname(l2),
              j2*2-1,
              nr[iph[pairc][1]][iso1],lname(l1),
              j1*2-1,
              sum_out);
    strengthfile << eph[pairc] << " " << abs0(sum_out) << endl;

    }
    sum_test+=sum_out;
   //    if (abs0(sum_out)>0.1)
   //    {
   //     if (iso == 1) sum_out_neutron+=abs0(sum_out);
   //     else sum_out_proton+=abs0(sum_out);
   //    }
    }
    printf("Sum XX-YY after normalization * 100 = %lf\n", sum_test);
 //   printf("Sum XX-YY for protons =%lf\n", sum_out_proton);
 //   printf("Sum XX-YY for neutrons=%lf\n", sum_out_neutron);
    }



    	   
    double2(xplot);
    double2init(xplot,5000,2);
    double lplusval;
    double lminusval;
    double1(gamlor);
    const double xxl = 0.01;
    int xi;    
 
    int en_count = 0;
    double1(xplot_plus_max);
    double1(xplot_minus_max);

    double1init(xplot_plus_max,2);
    double1init(xplot_minus_max,2);
    double1init(gamlor,2);    
    double orig_plus_max, orig_minus_max; 
    xplot_plus_max[1] = zero;
    xplot_minus_max[1] = zero;
    orig_plus_max = zero;
    orig_minus_max = zero;


    double1init(gamlor,2);
    gamlor[1] = lswid;
    gamlor[2] = lvwid;


   
    for (energyc = energy_start; energyc <= ndim_o_c; energyc++) 
    {
	if (c_erpa[energyc] == zero)
	  erp_ok = 1;
	else
	  erp_ok = 0;
	
	if ((charge[energyc] > 0.0 || erpa[energyc] < -1000.0) 
	            &&  (erpa[energyc] < exc_erg_max) && (erp_ok == 1)) 
	    {	    
	        en_count++;
		double eminus = erpa[energyc];//  -ala[1]+ala[2];
		double eplus = 	erpa[energyc];//  +ala[1]-ala[2];    	

	        if (j == 0 && natural_parity ==1) 
	        {	
	            if(ias[energyc][1] > orig_minus_max) 
	                    orig_minus_max=ias[energyc][1];
                            skalfile << eminus << "\t"
	                             << ias[energyc][1] << endl; 
		            lminusval = ias[energyc][1];
			    
	            if(ias[energyc][2] > orig_plus_max) 
	                    orig_plus_max=ias[energyc][2];
                            vecfile << eplus << "\t"
	                             << ias[energyc][2] << endl; 
		            lplusval = ias[energyc][2];    
	        }
		else if(j==1 && natural_parity == 0)
		{
	            if(gtr[energyc][1] > orig_minus_max) 
	                    orig_minus_max=gtr[energyc][1];
                            skalfile << eminus << "\t"
	                             << gtr[energyc][1] << endl; 
		            lminusval = gtr[energyc][1];
			    
	            if(gtr[energyc][2] > orig_plus_max) 
	                    orig_plus_max=gtr[energyc][2];
                            vecfile << eplus << "\t"
	                             << gtr[energyc][2] << endl; 
		            lplusval = gtr[energyc][2];    		   
		}	
	        else if( (j == 1 && natural_parity == 1) ||
		         (j==0 && natural_parity == 0) ||
			 (j==2 && natural_parity == 0) ) //SDR	
		{
	            if(sdr[energyc][1] > orig_minus_max) 
	                    orig_minus_max=sdr[energyc][1];
                            skalfile << eminus << "\t"
	                             << sdr[energyc][1] << endl; 
		            lminusval = sdr[energyc][1];
			    
	            if(sdr[energyc][2] > orig_plus_max) 
	                    orig_plus_max=sdr[energyc][2];
                            vecfile << eplus << "\t"
	                             << sdr[energyc][2] << endl; 
		            lplusval = sdr[energyc][2];		   
		}		
	        for (xi = 0; xi <= 5000; xi++)
	        {
		    xplot[xi][1] += lminusval*1./(pow(xi*xxl-eminus,2.)
					     + (gamlor[1]*gamlor[1])/4.)
		                             *(gamlor[1]/(2.*pi));	
		    xplot[xi][2] += lplusval*1./(pow(xi*xxl-eplus,2.)
					     + (gamlor[2]*gamlor[2])/4.)
		                             *(gamlor[2]/(2*pi));   
		    if ((xplot[xi][1] > xplot_minus_max[1])&&(xi > 300)) 
		    {		    
		        xplot_minus_max[1] = xplot[xi][1];
		        xplot_minus_max[2] = xi*xxl;
		    }
		    if ((xplot[xi][1] > xplot_plus_max[1])&&(xi > 300)) 
		    {		    
		        xplot_plus_max[1] = xplot[xi][2];
		        xplot_plus_max[2] = xi*xxl;
		    }		    			
	        }	        
	    } 		
    }
    
    lorskalfile << "#width: " << gamlor[1] << endl;
    lorskalfile << "#maximum value: " << xplot_minus_max[1] << endl;
    lorskalfile << "#at energy: " << xplot_minus_max[2] << endl;    
	
    for (xi = 0; xi <= 5000; xi++)
    {
	lorskalfile << xi*xxl << "\t" << xplot[xi][1] << endl;
    }
    
    lorvecfile << "#width: " << gamlor[2] << endl;
    lorvecfile << "#maximum value: " << xplot_plus_max[1] << endl;
    lorvecfile << "#at energy: " << xplot_plus_max[2] << endl;    
	
    for (xi = 0; xi <= 5000; xi++)
    {
	lorvecfile << xi*xxl << "\t" << xplot[xi][2] << endl;
    }

    // writing "pure" data-files

    purskalfile.open(filepskal, ios::out | ios::trunc);
    purskalfile.setf(ios::scientific);

    purskalfile << en_count << endl;      

    for (energyc = energy_start; energyc <= ndim_o_c; energyc++) 
    {
	if (c_erpa[energyc] == zero)
	  erp_ok = 1;
	else
	  erp_ok = 0;		
	
	if ((charge[energyc] > 0.0 || erpa[energyc] < -1000.0)  
	      && (erpa[energyc] < exc_erg_max) && (erp_ok == 1)) 
	{

	    if (j == 0 && natural_parity == 1)
	    {		
		purskalfile << erpa[energyc] << "\t" << ias[energyc][1]
		  << endl;
	    }
	    else if (j == 1 && natural_parity == 0)
	    {
		purskalfile << erpa[energyc] << "\t" << gtr[energyc][1]
		  << endl;	        
	    }
            else if ( (j == 0 && natural_parity == 0) ||
                      (j == 1 && natural_parity == 1) ||
                      (j == 2 && natural_parity == 0) )
            {
                purskalfile << erpa[energyc] << "\t" << sdr[energyc][1]
                  << endl;
            }
	}
    }


    // calculating sum-rules

    double m_0p_sum = zero;
    double m_0m_sum = zero;
    double m_1p_sum = zero;
    double m_1m_sum = zero;    

    double1(m_0p);
    double1init(m_0p,ndim_o_c);
    double1(m_0m);
    double1init(m_0m,ndim_o_c);        

    
    int en_lauf = 0;
    int enswitch = 0;
    

 //  for (energyc = npair+1; energyc <= 2*npair; energyc++) 
     for (energyc = 1; energyc <= 2*npair; energyc++)    
    {
	if (c_erpa[energyc] == zero)
	  erp_ok = 1;
	else
	  erp_ok = 0;	 
	
	if ((charge[energyc] > 0  || erpa[energyc] < -1000.0  ) && (erp_ok == 1)
	       && (erpa[energyc] <  exc_erg_max)  ) 
	{
	    en_lauf++;
	    
	    // IAS
	    if (j == 0 && natural_parity == 1) 
	    {		
		m_0m[en_lauf] = ias[energyc][1];
		m_0m_sum += m_0m[en_lauf];
                m_1m_sum += erpa[energyc]*ias[energyc][1];
		m_0p[en_lauf] = ias[energyc][2];
		m_0p_sum += m_0p[en_lauf];
                m_1p_sum += erpa[energyc]*ias[energyc][2];
				
		strengthfile << erpa[energyc] << "\t" << m_0m_sum 
		 << "\t"  << m_0p_sum << "\t" << m_0m_sum - m_0p_sum << endl;	
	    }
	    else if(j == 1 && natural_parity == 0)
	    {
		m_0m[en_lauf] = gtr[energyc][1];
		m_0m_sum += m_0m[en_lauf];
                m_1m_sum += erpa[energyc]*gtr[energyc][1];
		m_0p[en_lauf] = gtr[energyc][2];
		m_0p_sum += m_0p[en_lauf];
                m_1p_sum += erpa[energyc]*gtr[energyc][2];

		strengthfile << erpa[energyc] << "\t" << m_0m_sum 
		 << "\t"  << m_0p_sum << "\t" << m_0m_sum - m_0p_sum << endl;	
	    }
	    else if( (j == 1 && natural_parity == 1) ||
		         (j==0 && natural_parity == 0) ||
			 (j==2 && natural_parity == 0) ) //SDR	
	    {
		m_0m[en_lauf] = sdr[energyc][1];
		m_0m_sum += m_0m[en_lauf];
		m_0p[en_lauf] = sdr[energyc][2];
		m_0p_sum += m_0p[en_lauf];		
		strengthfile << erpa[energyc] << "\t" << m_0m_sum 
		 << "\t"  << m_0p_sum << "\t" << m_0m_sum - m_0p_sum << endl;	
	    }	    
	}
    }
        
    double sumrule;
    if (j == 0 && natural_parity == 1)
    {	
        strengthfile << "#" <<endl;
	strengthfile << "#IAS Sum: " << "\t" << m_0m_sum - m_0p_sum << endl;
	sumrule = nneu-npro;
	strengthfile << "#Percentage of sum rule: "
	     << 100.0*(m_0m_sum-m_0p_sum)/sumrule << endl;
        strengthfile << "# m1/m0 (-) = " << m_1m_sum/m_0m_sum-ala[1]+ala[2] <<endl;
        strengthfile << "# m1/m0 (+) = " << m_1p_sum/m_0p_sum+ala[1]-ala[2] << endl;
    }
    else if(j==1 && natural_parity == 0)
    { 
        strengthfile << "#" <<endl;
	strengthfile << "#GTR Sum: " << "\t" << m_0m_sum - m_0p_sum << endl;
        sumrule = 3.0*(nneu-npro);
        strengthfile << "#Percentage of sum rule: "
             << 100.0*(m_0m_sum-m_0p_sum)/sumrule << endl;
        strengthfile << "#GT- Sum : " << "\t" << m_0m_sum << endl;
        strengthfile << "#GT+ Sum : " << "\t" << m_0p_sum << endl; 
	
	sumrule = 3.0*(nneu-npro);

	strengthfile << "#Percentage of sum rule: "
	     << 100.0*(m_0m_sum-m_0p_sum)/sumrule << endl;
        strengthfile << "# m1/m0 (-) = " << m_1m_sum/m_0m_sum-ala[1]+ala[2] <<endl;
        strengthfile << "# m1/m0 (+) = " << m_1p_sum/m_0p_sum+ala[1]-ala[2] <<
endl;
	
    } 
    else if( (j == 1 && natural_parity == 1) ||
		         (j==0 && natural_parity == 0) ||
			 (j==2 && natural_parity == 0) ) //SDR	
    { 
        strengthfile << "#" <<endl;
	strengthfile << "#SDR Sum: " << "\t" << m_0m_sum - m_0p_sum << endl;	
	sumrule = (2*j+1)*(nneu*pow(rmsn_2,2.0)-npro*pow(rmsp_2,2.0));
	strengthfile << "#Percentage of sum rule: "
	     << 100.0*(m_0m_sum-m_0p_sum)/sumrule << endl;	
    }         
/*
// --------------------------------------------------------------
//
//             neutrino-nucleus cross sections
//
//---------------------------------------------------------------

 fstream nucs_m;
 fstream nucs_p;

 const double Gf = 1.16639e-11;
 const double TanCabbibo = 0.25;
 const double ga = 1.26;
 const double delnH = 0.78227;
 double Vc0;
 
 double thetaC;
 double fact_const;
 double E_neutrino;
 double E_neutrino_max = 200.0;
 double E_neutrino_step = 1.0;
 double E_electron;
 double E_electron_eff;
 double p_electron;
 double p_electron_eff;
 double cross_section_m;
 double cross_section_p;
 double peR;
 double term_cs;
 

 nucs_m.open("csm.out", ios::out | ios::trunc);
 nucs_m.setf(ios::scientific);

 nucs_p.open("csp.out", ios::out | ios::trunc);
 nucs_p.setf(ios::scientific);


 thetaC = atan(TanCabbibo);

 fact_const = pow(Gf*cos(thetaC)*emass*hqc*1e-13,2)/pi;

 cout << "fact = " << fact_const << endl;

 E_neutrino = 0.0;

 while(E_neutrino <= E_neutrino_max)
 {
  
  cross_section_m = 0.0; 
  cross_section_p = 0.0;

  for (energyc = 1; energyc <= 2*npair; energyc++)
  {
   if (c_erpa[energyc] == zero)
      erp_ok = 1;
   else
      erp_ok = 0;

   if (erpa[energyc] > 0.0 && abs0(erpa[energyc]) < 1000.0
         && erp_ok == 1)
   {
            // IAS
          if (j == 0 && natural_parity == 1)
            {
                m_0m[en_lauf] = ias[energyc][1];
                m_0m_sum += m_0m[en_lauf];
                m_1m_sum += erpa[energyc]*ias[energyc][1];
                m_0p[en_lauf] = ias[energyc][2];
                m_0p_sum += m_0p[en_lauf];
                m_1p_sum += erpa[energyc]*ias[energyc][2];
     
            // GTR  
            if(j == 1 && natural_parity == 0)
            {
           
             E_electron = E_neutrino
                          + ala[1]-ala[2]+delnH-erpa[energyc]; 
             if(E_electron >= emass)
              p_electron = sqrt(abs0(pow(E_electron/emass,2)-1.0));
             peR = p_electron*emass*rms_2_ch/hqc;
          
             // effective momentum approximation
           
             if( E_electron < 0 ) Vc0 = 0.0;
             else  Vc0 = 3.0*npro*alpha*hqc/(2.0*rms_2_ch);

             E_electron_eff = E_electron - Vc0;

             if (E_electron_eff >= emass)
             {
              p_electron_eff = sqrt(abs0(pow(E_electron_eff/emass,2)-1.0));

      //        cout << E_neutrino << " " << E_electron << " "
      //            << E_electron_eff << " " << peR << endl;

              term_cs = p_electron_eff*(E_electron_eff/emass)  
                        *gtr[energyc][1] 
                        *pow(p_electron_eff/p_electron,2);

              if( E_electron < 0 )
               cross_section_m += term_cs*fermi(npro+1,nama,p_electron_eff);
              else
               cross_section_m += term_cs;
             }

             E_electron = E_neutrino
                          - ala[1]+ala[2]-delnH-erpa[energyc];
             
             if (E_electron > 0.0 && E_electron >= emass)
             {

              p_electron = sqrt(abs0(pow(E_electron/emass,2)-1.0));
 
              cross_section_p += p_electron*E_electron  
                                *fermi(npro-1,nama,p_electron)
                                *gtr[energyc][2];

             }

            } // if gtr

   } // if erpa

  } // for energyc   

   cross_section_m *= fact_const*1e40;
   cross_section_p *= fact_const*1e40;
 
   nucs_m << E_neutrino << " " << cross_section_m << endl;
   nucs_p << E_neutrino << " " << cross_section_p << endl;

   E_neutrino += E_neutrino_step;

 } // while E_neutrino

 nucs_m.close();
 nucs_p.close();
 
//---------------------------------------------------------------   
*/
} // excstr


static int lcal(int lc, int jc, int bil)
{
    

    if (bil == 1)
      return lc;
    
    else 
    {
	if (lc < jc)
	  return jc;
	else
	  return (lc-1);
    }
}



static void write_head(fstream &resfile, int ispar, int ihar)
{
    int i;
    
    
    resfile << "#RPA-results:" << endl;
    resfile << "#Nucleus: " << nucnam << " " << nama << endl;
    resfile << "#Fermi level: " << ala[1] << "\t" << ala[2] << endl;
    resfile << "#Excitation: ";
    resfile << j;
      
    if (parity == 0)
      resfile << " -" << endl;
    else
      resfile << " +" << endl;
      	
      resfile << "#Total number of pairs: " << npair << endl; 
      resfile << "#Number of ph-/ah-pairs: " <<
	  npair_ph << "/" << npair_ah << endl;

      resfile 
	  << "#Maximal excitation-energy for particle-hole-pairs: " 
	    << int(ediffmaxu)
	      << endl;
      resfile 
	  << "#Maximal excitation-energy for antiparticle-hole-pairs: " 
	    << int(ediffmaxd)
	      << endl;

    if (im_count > 0)
      resfile << "#" << im_count << " imaginary eigenvalues" << endl;
    else
      resfile << "#No imaginary eigenvalues" << endl;

    if (im_count > 0) 
    {
	resfile << "#Listing imaginary eigenvalues:" << endl;
	
	for (i = 1; i <= im_count; i++)
	{
	    resfile << "#Imaginary part: " << erpa_im[i][1] << endl;
	    resfile << "#Real part: " << erpa_im[i][2] << endl;
	}
    }
    resfile << endl;
    
    
    resfile << "#Parameterset: " << txtfor << endl;

    if (natural_parity == 1)
      resfile << "#natural parity: yes" << endl;
    else
      resfile << "#natural parity: no" << endl;
    
    if (ispar == 0)
      resfile << "#Isoscalar result:" << endl;
    else if (ispar == 1)
      resfile << "#Isovector result:" << endl;

    if (ihar == 1)
      resfile << "#Hartree-Solution!!" << endl;
    
    if (calc == 0)
    {
	if (calcfile_found == 1) 
	{	    
	    resfile << "#relevant interaction parameters " 
	      << "from the original calculation:"
		<< endl;
	    resfile << "#calc_j = " << calc_j << endl;
	    resfile << "#calc_parity = " << calc_parity << endl;
	    resfile << "#calc_ediffmaxu = " << calc_ediffmaxu << endl;
	    resfile << "#calc_ediffmaxd = " << calc_ediffmaxd << endl;
	    resfile << "#calc_xyprint = " << calc_xyprint << endl;
	    resfile << "#calc_hartree = " << calc_hartree << endl;
	}
	else 
	{
	    resfile << "#original file calc.out not found" << endl;
	    resfile << "#please makes sure that binary matrices" 
	      << "matching your calculation" << endl;
	    resfile << "#relevant interaction parameters " 
	      << "from file start.dat"
		<< endl;
	    resfile << "#j = " << j << endl;
	    resfile << "#parity = " << parity << endl;
	    resfile << "#ediffmaxu = " << ediffmaxu << endl;
	    resfile << "#ediffmaxd = " << ediffmaxd << endl;
	    resfile << "#xyprint = " << xyprint << endl;
	    resfile << "#hartree = " << hartree << endl;
	}
    }
    
	
    resfile << endl;
    


}

static char lname(int nn)
{
 
  char lang[]= {'s','p','d','f','g','h','i','j','k','l','m','n',
    'o','\0'};
  char notkn[] = "?";

  if (nn > 11) return notkn[0];
  else return lang[nn];
}
/*
double fermi(int z,int a,double p)
{

   const double em2=0.261124;
   const double a2em=2.721046e-5;
   const double hc=0.01013;
   const double ro=1.3;
   const double screen=1.43;
   
   
   double alphaz,vo,w,ww,pp,xnu;
   double gammo,r,so,rr,ri,tmp,tmp1,x,f1,f2;
   
   alphaz=alpha*z;
   vo=sign(1.0,z)*screen*a2em*pow(abs(z),1.333333);
   w=sqrt(p*p+em2);   
   ww=w-vo;
   if(ww<emass) return 0;
   pp=sqrt(ww*ww-em2);
   gammo=(double)sqrt(1.0-alphaz*alphaz);
   xnu=alphaz*ww/pp;
   r=ro*pow(a,0.333333);
   so=-2.0*(1-gammo);

   cdgamma(gammo,xnu,&rr,&ri);
   tmp=rr*rr+ri*ri;
   tmp=log(tmp);
   tmp=tmp+pi*xnu;
   
   x=(double)2.0*gammo+1.0;
   cdgamma(x,0.0,&rr,&ri);
   tmp1=rr*rr+ri*ri;
   tmp1=log(tmp1);
   tmp=tmp-tmp1;
   tmp=exp(tmp);
   
   f1=2*(1.0+gammo)*pow((hc*r*pp),so);
   f2=pp*ww/(p*w);
   
   return f1*f2*tmp;
}


void cdgamma(double xr, double xi, double *yr, double *yi)
{

   const double pi = 3.14159265358979324;
   const double pv = 7.31790632447016203; 
   const double pu = 3.48064577727581257; 
   const double pr = 3.27673720261526849e-2; 
   const double p1 = 1.05400280458730808e+1;
   const double p2 = 4.73821439163096063e+1;
   const double p3 = 9.11395751189899762e+1;
   const double p4 = 6.62756400966213521e+1;
   const double p5 = 1.32280130755055088e+1;
   const double p6 = 2.93729529320536228e-1;
     
   const double q1 = 9.99999999999975753e-1;
   const double q2 = 2.00000000000603851;
   const double q3 = 2.99999999944915534;
   const double q4 = 4.00000003016801681;
   const double q5 = 4.99999857982434025;
   const double q6 = 6.00009857740312429;
   
   double wr,wi,ur,ui,vr,vi,t;
   
   if(xr<0)
   {
      wr=1-xr;
      xi=-xi;
   }
   else
   {
      wr=xr;
      wi=xi;
   }
      
   ur = wr + q6;
   vr = ur * (wr + q5) - wi * wi;
   vi = wi * (wr + q5) + ur * wi;
   *yr = p6 + (p5 * ur + p4 * vr);
   *yi = p5 * wi + p4 * vi;
   ur = vr * (wr + q4) - vi * wi;
   ui = vi * (wr + q4) + vr * wi;
   vr = ur * (wr + q3) - ui * wi;
   vi = ui * (wr + q3) + ur * wi;
   *yr = *yr + (p3 * ur + p2 * vr);
   *yi = *yi + (p3 * ui + p2 * vi);
   ur = vr * (wr + q2) - vi * wi;
   ui = vi * (wr + q2) + vr * wi;
   vr = ur * (wr + q1) - ui * wi;
   vi = ui * (wr + q1) + ur * wi;
   *yr = *yr + (p1 * ur + vr);
   *yi = *yi + (p1 * ui + vi);
   ur = vr * wr - vi * wi;
   ui = vi * wr + vr * wi;
   t = ur * ur + ui * ui;
   vr = (*yr * ur + *yi * ui) + pr * t;
   vi = *yi * ur - *yr * ui;
   *yr = wr + pv;
   ur = (double)0.5 * log(*yr * *yr + wi * wi) - 1;
   ui = atan2(wi, *yr);
   *yr = exp(ur * (wr - 0.5) - ui * wi - pu) / t;
   *yi = ui * (wr - 0.5) + ur * wi;
   ur = *yr * cos(*yi);
   ui = *yr * sin(*yi);
   *yr = ur * vr - ui * vi;
   *yi = ui * vr + ur * vi;
   if(xr<0)
   {
       wr = pi * xr;
       wi = exp(pi * xi);
       vi = (double)1 / wi;
       ur = (vi + wi) * sin(wr);
       ui = (vi - wi) * cos(wr);
       vr = ur * *yr + ui * *yi;
       vi = ui * *yr - ur * *yi;
       ur = 2 * pi / (vr * vr + vi * vi);
       *yr = ur * vr;
       *yi = ur * vi;
   }
        
}


double sign(double arg1, double arg2)
{
   if(arg2<0)
      return -1*arg1;
   else
      return arg1;
      
}

*/
