#include "common.h"
#include "prep.h"
#include "funk.h"
#include "base.h"
#define NRANSI
#include "nr.h"
#include "nrutil.h"

static int lcal(int, int, int);

double3(yjl);
double2(yjl_pi);

void jlyl()
{
    int pair,iq,ir;
    int st1,st2,t1,t2,l1,l2,j1,j2,l1g,l2g;
    double ang0,ang1,ang2,ang3,ang4,ang5,ang6,ang7,ang8,ang9,ang10;
    double sumf,sumg,sumfgm,sumfgp,sumgfm,sumgfp;
    double sumfv,sumgv,sumf1v,sumg1v,sumf2v,sumg2v;
    double sumftv,sumgtv,sumf1tv,sumg1tv,sumf2tv,sumg2tv;
    double sumfc,sumgc,sumf1c,sumg1c,sumf2c,sumg2c;
    double weight,wf,wg;        
    double qr,sj,sy,sjp,syp,fg12,gf12,ff,gg;
    
    double3init(yjl,maxq,npair,4);
    double2init(yjl_pi,maxq,npair);    
    for (pair = 1; pair <= npair; pair++)
    {

        st1 = iph[pair][1];
        st2 = iph[pair][2];
	
        t1 = iph[pair][3];
	t2 = iph[pair][4];
	
        l1 = nl[st1][t1];
        l2 = nl[st2][t2];
	
        j1 = nj[st1][t1];
        j2 = nj[st2][t2];

        l1g = lcal(l1,j1,2);
        l2g = lcal(l2,j2,2);
   
        
	if(natural_parity == 1)
	{
           ang0 = yjj(j1,l1,j2,l2,j);
	   ang1 = syjj(j1,l1,j2,l2g,j+1,j);
	   ang2 = syjj(j1,l1g,j2,l2,j+1,j);
	
	   if(j !=0)
	   {
	      ang3 = syjj(j1,l1,j2,l2g,j-1,j);
	      ang4 = syjj(j1,l1g,j2,l2,j-1,j);
	   }
	   else
	   {
	      ang3 = ang4 = 0.0;
	   }
	}   
	else if(natural_parity == 0)
	{	    
	   ang5 = syjj(j1,l1,j2,l2g,j,j);      //vector meson spatial
	   ang6 = syjj(j1,l1g,j2,l2,j,j);      //vector meson spatial
	   ang7 = syjj(j1,l1,j2,l2,j+1,j);     //pion
	   ang8 = syjj(j1,l1g,j2,l2g,j+1,j);   //pion
	   if(j!=0)
	   {
	      ang9 = syjj(j1,l1,j2,l2,j-1,j);     //pion 
	      ang10 = syjj(j1,l1g,j2,l2g,j-1,j);  //pion
	   }
	   else
	   {
	      ang9 = 0.0;
	      ang10 = 0.0;
	   }      	
	}
	else
	{
	   cout << "Error in natural_parity..." << endl;
	   cout << "natural_parity = " << natural_parity << endl;
	   exit(1);
	}      	   
        for(iq = 1; iq <= maxq; iq++)
	{
	    if(natural_parity == 1)
	    {
		sumf = 0.0;
		sumg = 0.0;
		sumfgp = sumgfp = sumfgm = sumgfm = 0.0;			
	        for(ir = 1; ir <= maxr; ir++)
	        {
	         // time like parts of the rho-meson
	             qr = qmesh[iq]*rmesh[ir];
		     sphbes(j,qr,&sj,&sy,&sjp,&syp);
		     wf = wfg[st1][ir][t1]*wfg[st2][ir][t2];
		     wg =  wfg[st1][ir+maxr][t1]*wfg[st2][ir+maxr][t2];
		     weight = sj*pow(rmesh[ir],2.0)*rweight[ir]; 
		     
		     sumf += wf*grho[ir]*weight;
		     sumg += wg*grho[ir]*weight;   
		                            
                 // space-like parts of vector mesons
		 		     	     
	             fg12 = wfg[st1][ir][t1]*wfg[st2][ir+maxr][t2]*
		        pow(rmesh[ir],2.0)*rweight[ir];
	             gf12 = wfg[st1][ir+maxr][t1]*wfg[st2][ir][t2]*
		        pow(rmesh[ir],2.0)*rweight[ir];
                     sphbes(j+1,qr,&sj,&sy,&sjp,&syp);
		     sumfgp += sj*fg12*grho[ir];
		     sumgfp += sj*gf12*grho[ir];	     
		 
		     if (j != 0)
		     {
		         sphbes(j-1,qr,&sj,&sy,&sjp,&syp);		
		         sumfgm += sj*fg12*grho[ir];
		         sumgfm += sj*gf12*grho[ir];	
		     }
                 }
		 
		 yjl[iq][pair][1] = ang0*(sumf+sumg); //time-like rho
		 yjl[iq][pair][2] = (ang1*sumfgp - ang2*sumgfp); //spatial rho
	         yjl[iq][pair][3] = (ang3*sumfgm - ang4*sumgfm);
		 		 		 
              }
	      else  if(natural_parity == 0)//unnatural parity
	      {
	         double sumfg = 0.0;
		 double sumgf = 0.0;		 
		 double sumffp = 0.0;
		 double sumggp = 0.0;
		 double sumffm = 0.0;
		 double sumggm = 0.0;
		 
		 for(ir = 1; ir <= maxr; ir++)
	         {
	             qr = qmesh[iq]*rmesh[ir];		     
		     
		     fg12 = wfg[st1][ir][t1]*wfg[st2][ir+maxr][t2]*
		        pow(rmesh[ir],2.0)*rweight[ir];
	             gf12 = wfg[st1][ir+maxr][t1]*wfg[st2][ir][t2]*
		        pow(rmesh[ir],2.0)*rweight[ir];
                     sphbes(j,qr,&sj,&sy,&sjp,&syp);
		     sumfg += sj*fg12*grho[ir];
		     sumgf += sj*gf12*grho[ir];		         
		     
		     ff = wfg[st1][ir][t1]*wfg[st2][ir][t2]*
		        pow(rmesh[ir],2.0)*rweight[ir];
	             gg = wfg[st1][ir+maxr][t1]*wfg[st2][ir+maxr][t2]*
		        pow(rmesh[ir],2.0)*rweight[ir];	
                     sphbes(j+1,qr,&sj,&sy,&sjp,&syp);
		     sumffp += sj*ff;
		     sumggp += sj*gg;
		     if(j != 0)
		     {
		        sphbes(j-1,qr,&sj,&sy,&sjp,&syp);		     
		        sumffm += sj*ff;
		        sumggm += sj*gg;
                     }					        
		 }
		 yjl[iq][pair][1] = ang5*sumfg - ang6*sumgf; //rho
		 yjl_pi[iq][pair] = 
		     sqrt(double(j+1))*(ang7*sumffp + ang8*sumggp)+
		     sqrt(double(j))*(ang9*sumffm + ang10*sumggm);  
	      }
	      else
	      {
	         cout << "Error in natural_parity..." << endl;
	         cout << "natural_parity = " << natural_parity << endl;
	         exit(1);
	      }   
         }
     }	
}

static int lcal(int lc, int jc, int bil)
{    
    if (bil == 1)
      return lc;
    
    else 
    {
	if (lc < jc)
	  return jc;
	else
	  return (lc-1);
    }
}    
      
