#include "common.h"
#include "base.h"
#include "sla.h"
#include "funk.h"
#include "mesh.h"
#include "prep.h"

double matcon0(int pair1, int pair2)

{                
    int t1, t2, t3, t4; 
    int iq1,iq2; 
    int coul;  
    double matsum0;
    double matsum_pi, matsum_rho;    
    double del;
    
    matsum0 = zero;

    matsum_rho = matsum_pi = zero;

    t1 = iph[pair1][3];
    t3 = iph[pair1][4];    
    t2 = iph[pair2][4];
    t4 = iph[pair2][3];
               
    if (natural_parity == 1)
    {
       for (iq1 = 1; iq1 <= maxq; iq1++)
       {  
	    matsum_rho += ddrho[iq1]*yjl[iq1][pair1][1]*yjl[iq1][pair2][1]*
	                  isospin(1,t1,t2,t3,t4);  
       }       
       matsum0 = matsum_rho;
    }
    else
    {
       for (iq1 = 1; iq1 <= maxq; iq1++)
       { 
	   matsum_pi -= ddpi[iq1]*yjl_pi[iq1][pair1]*yjl_pi[iq1][pair2];
	   matsum_rho -= ddrho[iq1]*
	         yjl[iq1][pair1][1]*yjl[iq1][pair2][1];	         
       }
       del = deltapi(pair1,pair2);
       matsum0 = (matsum_rho + matsum_pi+del)*isospin(1,t1,t2,t3,t4);  
    }	       
    return matsum0;
}
    
