#include "common.h"
#include "base.h"
#include "sla.h"
#include "funk.h"
#include "edmonds.h"
#include "mesh.h"
#include "prep.h"
#include "nr.h"
#include "nrutil.h"




double sinradjl(int st1, int l1,
              int st2, int l2, int l,double kappa,
              int l_rho_term, int only_jl_term, int der_term,int isign)

{

    register double radproint1 = zero;
    register double radproint2 = zero;
    register double sinradret = zero;
    register double r;
   
    double bes_sj, bes_sy, bes_sjp, bes_syp;
    register double qrarg;
    
    int it1, it2;

    register int i, k, index;

//    it1=1;
//    it2=2;
  
     it1 =2; //proton
     it2 =1; //neutron
    

    for (i = 1; i <= maxr; i++)
    {

        qrarg = kappa*rmesh[i]/hqc;
 
        if(kappa == qtold && l == lold)
        {
         bes_sj = bessf[i];
        }
        else
        {

        if(l >= 0  || qrarg <= 0.1)
          sphbes(l,qrarg,&bes_sj,&bes_sy,&bes_sjp,&bes_syp);
//          cout <<"bes_sj = " <<  bes_sj << endl;

        else
        switch(l)
        {
         case 0:
           bes_sj = sin(qrarg)/qrarg;
           break;
 
         case 1:
           bes_sj = sin(qrarg)/pow(qrarg,2)-cos(qrarg)/qrarg;
           break;
           
         
         case 2:

         bes_sj = -((3*qrarg*cos(qrarg) + (-3 + pow(qrarg,2))*sin(qrarg))/
                  pow(qrarg,3));
         break;

         case 3:

         bes_sj = (qrarg*(-15 + pow(qrarg,2))*cos(qrarg) + 
                  3*(5 - 2*pow(qrarg,2))*sin(qrarg))/pow(qrarg,4);
         break;

         case 4:

         bes_sj = (5*qrarg*(-21 + 2*pow(qrarg,2))*cos(qrarg) + 
                  (105 - 45*pow(qrarg,2) + pow(qrarg,4))*sin(qrarg))/pow(qrarg,5);
         break;

         case 5:

         bes_sj = (-(qrarg*(945 - 105*pow(qrarg,2) + pow(qrarg,4))*cos(qrarg)) + 
                  15*(63 - 28*pow(qrarg,2) + pow(qrarg,4))*sin(qrarg))/pow(qrarg,6);
         break;

         case 6:

         bes_sj = -((21*qrarg*(495 - 60*pow(qrarg,2) + pow(qrarg,4))*cos(qrarg) + 
                  (-10395 + 4725*pow(qrarg,2) - 210*pow(qrarg,4) + pow(qrarg,6))*
                   sin(qrarg))/pow(qrarg,7));
         break;

         case 7:

         bes_sj = (qrarg*(-135135 + 17325*pow(qrarg,2) - 378*pow(qrarg,4) + 
                  pow(qrarg,6))*cos(qrarg) - 
                  7*(-19305 + 8910*pow(qrarg,2) - 450*pow(qrarg,4) + 4*pow(qrarg,6))*
                  sin(qrarg))/pow(qrarg,8);
         break;

         case 8:


         bes_sj = (9*qrarg*(-225225 + 30030*pow(qrarg,2) - 770*pow(qrarg,4) + 
                  4*pow(qrarg,6))*cos(qrarg) + 
                  (2027025 - 945945*pow(qrarg,2) + 51975*pow(qrarg,4) - 
                  630*pow(qrarg,6) + pow(qrarg,8))*sin(qrarg))/pow(qrarg,9);
         break;

 
        }
      
 
        bessf[i] = bes_sj;
//        cout <<" bessf = " << bessf[i] <<endl;
        if(i == maxr)
         {  
          qtold = kappa;
          lold = l;
         }

        }   
       
        if(der_term == 1)
        {

//         radproint1 += bwf.wf[st1-1][i-1]
//                      *(bwf.dwf[st2-1][i-1]-bwf.wf[st2-1][i-1]/rmesh[i])
//                      *rweight[i]*bes_sj;

           
        
//          radproint1 += ((wfg[st1][i][it1]*dwfg[st2][i][it2] + wfg[st1][i+maxr][it1]*dwfg[st2][i+maxr][it2]) - (wfg[st1][i][it1]*wfg[st2][i][it2]+wfg[st1][i+maxr][it1]*wfg[st2][i+maxr][it2])/rmesh[i])*rweight[i]*bes_sj; 


//         radproint1 += (wfg[st1][i][it1]*dwfg[st2][i][it2] + wfg[st1][i+maxr][it1]*dwfg[st2][i+maxr][it2])*rweight[i]*bes_sj*rmesh[i]*rmesh[i];

           radproint1 += ( wfg[st1][i+maxr*isign][it1]*dwfg[st2][i+maxr*isign][it2])*rweight[i]*bes_sj*rmesh[i]*rmesh[i];

      }

        if(only_jl_term == 0) 
        bes_sj *= l_rho_term/rmesh[i]; 
 
//        radproint2 += bwf.wf[st1-1][i-1]
//                     *bwf.wf[st2-1][i-1]
//                     *rweight[i]*bes_sj;

//       radproint2 += (wfg[st1][i][it1]*wfg[st2][i][it2]+wfg[st1][i+maxr][it1]*wfg[st2][i+maxr][it2])*rweight[i]*bes_sj*rmesh[i]*rmesh[i];

         radproint2 += (wfg[st1][i+maxr*isign][it1]*wfg[st2][i+maxr*isign][it2])*rweight[i]*bes_sj*rmesh[i]*rmesh[i];
    }
    sinradret = radproint1 + radproint2;

//    cout << "sinradret = " << sinradret << endl;
 
    return sinradret;
}

/*
static double Yred(int l1, int j1, int l2, int j2, int j) 
{

    double yred_ret=0.0;
    
    if ((j > (l1+l2)) ||(j < abs0(l1-l2))) 
      return yred_ret;
          
    yred_ret = (1.+iv[abs0(l1+l2+j)])/2.*
      sqrt((2*j+1)*(2*j1)*(2*j2)/(4*pi))*iv[j1-1]
	*wigner((j1-half),double(j),j2-half,-half,0.,half);
    return yred_ret;
}
   

int deriv(int irmesh,int stt, double *df, double *dg) 
{

// double step;
 int i, nmeshf;
 int itt = 2;
 nmeshf = nmesh+4; 

 double1(wfgf);
 double1init(wfgf,2*nmeshf); 

 for (i=1; i<= nmesh; i++)
 {
  wfgf[i] = wfg[stt][i][itt];
  wfgf[i+nmesh+4] = wfg[stt][i+nmesh][itt]; 
}

 for (i=1; i<=4; i++)
 {
  wfgf[nmesh+i] = 0.0;
  wfgf[nmesh+i+nmeshf] = 0.0;
 }

// for (i=1; i <= nmesh; i++ )
// { 

  i = irmesh;

     *df = (-25*wfgf[i] + 48.0*wfgf[i+1] - 36.0*wfgf[i+2] 
            + 16.0*wfgf[i+3] - 3.0*wfgf[i+4])/(12.0*hmesh);

     *dg = (-25.0*wfgf[i+nmeshf] + 48.0*wfgf[i+1+nmeshf] - 36.0*wfgf[i+2+nmeshf] 
            + 16.0*wfgf[i+3+nmeshf] - 3.0*wfgf[i+4+nmeshf])/(12.0*hmesh);

// }

   double1del(wfgf);  
   return 0;
  
}

*/
