#include "common.h"
#include "base.h"  
#include "funk.h"


int npair;
int jphmax;
int npair_ph;
int npair_ah;
int lphmax;

int2(iph); 
int2(kpp);
double1(eph);
//add for temperature
double2(umark);
double2(vmark);

void phpair(int, int);

void phpair(int j, int parity) {


    int il = 0, laufp;
    int il_ph, il_ah;  
    int it1,it2, i1, i2;
    int l1, j1, l2, j2, kl;
    int nal;
    double ediff = zero;
    int nst;
    int jphtemp;
    int lpart = 0;
    int lhole = 0;
    int en_ok;
    double uv12;
    double uv21;
    double cut_ah;
    int lphtemp;

    for (laufp = 1; laufp <= 2; laufp++) 
    {
	il = 0;
	il_ph = 0;
	il_ah = 0;


	for (it1 = 2; it1 <= 2; it1++) 
	{
	   if (it1 == 1)
	     it2 = 2;
	   else
	       it2 = 1;
	   for (i1 = 1; i1 <= ntpar[it1]; i1++) 
	   {
	  //proton states	 
	      j1 = nj[i1][it1];
	      l1 = nl[i1][it1];	    

	      for (i2 = 1; i2 <= ntpar[it2]; i2++) 
	      {
	         //neutron states
		 j2 = nj[i2][it2];
		 l2 = nl[i2][it2]; 
		 		 
		 en_ok = 0;
		 uv12 = abs0(uo[i1][it1]*vo[i2][it2]);
		 uv21 = abs0(uo[i2][it2]*vo[i1][it1]);		 

                 if(ee[i1][it1] < -1000.0) //ah states
		 {
		     if(ee[i2][it2] > -1000.0) //no aa pairs
		     {
		         cut_ah = 2.0*j2*vv[i2][it2];
                         if (cut_ah > 1.0)
		         {	
		            ediff = -ee[i2][it2]+ee[i1][it1];
		            if (fabs(ediff) <= ediffmaxd)
		               en_ok = -1;
			    else 
		               en_ok = 0;
			 }      	       		
		     } 
	         } 
	

                 if(ee[i1][it1] > -1000.0) //ah states
		 {
		     if(ee[i2][it2] < -1000.0) //no aa pairs
		     {
		         cut_ah = 2.0*j2*vv[i1][it1];
                         if (cut_ah > 1.0)
		         {	
		            ediff = ee[i2][it2]-ee[i1][it1];
		            if (fabs(ediff) <= ediffmaxd)
		               en_ok = -1;
			    else 
		               en_ok = 0;
			 }      	       		
		     } 
	         } 			 
		 
		 if(ee[i1][it1] > -1000.0 && ee[i2][it2] > -1000.0) //ph hp
		 {
		    if((uv12 >= qptresh) || (uv21 >= qptresh))
//                    if ((vv[i1][it1] > vv[i2][it2]) || (vv[i1][it1] < vv[i2][it2]) )
		    {
		       ediff = ee[i1][it1]-ee[i2][it2];
		      /* if (abs0(vo[i1][it1]) > 0.5)
		          ediff += ala[it1] - ala[it2];
	               else
		          ediff += ala[it2] - ala[it1];*/ 		  
		       if (fabs(ediff) <= ediffmaxu)
		          en_ok = 1;
		       else
		          en_ok = 0;	  
                    }
//		    if(abs0(vo[i1][it1]) < 0.5 && abs0(vo[i2][it2]) < 0.5)
//		    {
//		       if(ediff > 25.0 ) en_ok = 0;
//		    }
		 }    			  
		   // check angular momentum conditions for pairs    
		 if ((abs0(j1-j2) <= j) && (j <= (j1+j2-1))
		     && (((l1+l2+parity)%2) == 1) 
		     && ((en_ok == 1) ||(en_ok == -1))) 
		 {    
		     il += 1;
		     switch (en_ok)
		     {
			case 1 : il_ph += 1; break;
			case -1: il_ah += 1; break;
                     }
		     if (laufp == 2) 
		     {
			eph[il] = ediff;
			iph[il][1] = i1;
			iph[il][2] = i2;
			iph[il][3] = it1;
			iph[il][4] = it2;
			iph[il][5] = en_ok;    
		        kpp[i1][i2] = il;
// add for temperature
                        if (vv[i1][it1] > vv[i2][it2] )
                         {
                            vmark[il][1] = 1.0;
                            umark[il][1] = 0.0;
                            vmark[il][2] = 0.0;
                            umark[il][2] = 1.0;
                         }
                        else if (vv[i1][it1] < vv[i2][it2] )
                        {
                            vmark[il][1] = 0.0;
                            umark[il][1] = 1.0;
                            vmark[il][2] = 1.0;
                            umark[il][2] = 0.0;
                         }
// add end
		      } // if laufp = 2					
	         } // if triangle rule plus parity   
	      } // for i2		
	   } // for i1	    
	} // for it	
    	
	if (laufp < 2) 
	{
	   npair = il;
	   npair_ph = il_ph;
	   npair_ah = il_ah;	    	    
	   if (npair == 0) 
	   {
		cout << "there were no pairs found!" << endl
		  << "calculation will be terminated!" << endl;
		exit(-1);
	   }

	    // Allocation of Array-Objects

	    int2init(iph,npair,5); 
	    int2init(kpp,ntmax,ntmax);
	    double1init(eph,npair);
	    
//add for temperature

            double2init(umark, npair, 2);
            double2init(vmark, npair, 2); 	    	    
	} // if laufp < 2
		
    } // for laufp

//   cout << "... total number of pairs npair = " << npair << endl;  
     cout << "npair = " << npair << endl;

  // determination of maximal jp+jh and lp + lh


    jphmax = 0;
    lphmax = 0;
    int it11,it22;    

    for (i1 = 1; i1 <= npair; i1++)
    {
	for (i2 = 1; i2 <= npair; i2++)
	{
	
	    it11 = iph[i1][3];
	    it22 = iph[i2][4];
	    
    
	    jphtemp = min0(2,(nj[iph[i1][1]][it11]+nj[iph[i2][1]][it22]),
			   (nj[iph[i1][2]][it11]+nj[iph[i2][2]][it22]));
	    lphtemp = nl[iph[i1][1]][it11]+nl[iph[i2][1]][it22];
	    if((lphtemp > lphmax) && (iph[i1][5] == 1) && 
	         (iph[i2][5] == 1)) lphmax = lphtemp;
	
	    if (jphtemp > jphmax)
	      jphmax = jphtemp;
	}   
    }  
//    cout << "lphmax=" << lphmax << endl;
    return;
} // void pair












