#include "common.h"
#include "base.h"
#include "sla.h"
#include "funk.h"
#include "mesh.h"

#define float double
#define NRANSI
#include "nr.h"
#include "nrutil.h"



double3(fxi);
double3(fxe); 
double3(dxi);
double3(dxe);
double2(wro);
double2(wroerr);
int istart;
int iende;


void potdif()
{

    
    int i, l, nm;
    int na1, na2;
    double meffsta, meffend;
    double xmeshs, xmeshe;
    double pifakts, pifakte;
    double pifaktds, pifaktde;
    double fxinumr;
    double dxinumr;
    double fxenumr;
    double dxenumr;
    


    // allocation of arrays

    double3init(fxi,nmixmesh,lmax,nmass);
    double3init(fxe,nmixmesh,lmax,nmass); 
    double3init(dxi,nmixmesh,lmax,nmass);
    double3init(dxe,nmixmesh,lmax,nmass);
    double2init(wro,lmax,nmass);
    double2init(wroerr,lmax,nmass);
        
    cout << "... begining of potdif" << endl;

    for (nm = 1; nm <= nmass; nm++)
    {
	
	istart = 1;	
	iende = nmixmesh;    	
	xmeshs = rmesh[istart];

	xmeshe = rmesh[iende];
	
	meffsta = sqrt(meffsqx(xmeshs,nm));	
	meffend = sqrt(meffsqx(xmeshe,nm));

        
	xmeshs *= sqrt(meffsqx(xmeshs,nm));
	xmeshe *= sqrt(meffsqx(xmeshe,nm));

        
	pifakts = sqrt(pi*xmeshs/2.);
	pifaktds = sqrt(pi/(2.*xmeshs))/2.;    
	pifakte = sqrt(pi*xmeshe/2.);
	pifaktde = sqrt(pi/(2.*xmeshe))/2.;



	for (l = 0; l <= lmax; l++)
	{	
	    
	    bessik(xmeshs,(l+half),&fxinumr,&fxenumr,
		   &dxinumr,&dxenumr);	

	    
	    fxi[istart][l][nm] = pifakts*fxinumr;
	    dxi[istart][l][nm] = meffsta*(pifaktds*fxinumr+pifakts*dxinumr);
	    fxe[istart][l][nm] = pifakts*fxenumr;
	    dxe[istart][l][nm] = meffsta*(pifaktds*fxenumr+pifakts*dxenumr);
	    	    

	    bessik(xmeshe,(l+half),&fxinumr,&fxenumr,
		   &dxinumr,&dxenumr);

	    fxi[iende][l][nm] = pifakte*fxinumr;
	    dxi[iende][l][nm] = meffend*(pifaktde*fxinumr+pifakte*dxinumr);
	    fxe[iende][l][nm] = pifakte*fxenumr;
	    dxe[iende][l][nm] = meffend*(pifaktde*fxenumr+pifakte*dxenumr);

	    
	}


    }
    

}



