#include "common.h"
#include "prep.h"
#include "base.h"

double1(rmesh);
double1(qmesh);
double1(rweight);
double1(qweight);
double1(bessf);
double qstep;
double rstep;
int maxq;
int maxr;
double qtold;
int lold;


void prep()
{
    int ir,iq,mq1,mr1,ir1,iq1;
    double rs,qs;
    
    qstep = 0.125;
//    rstep = 0.05;
    rstep = hmesh;
    maxq = 49;
//    maxr = 401;
    maxr = nmesh;   
    qtold = -1.0;
    lold = -1; 
 
    cout<<"maxr= " << nmesh << "hmesh= " <<hmesh <<endl;    
 
    double1init(rmesh,maxr);
    double1init(qmesh,maxq);
    double1init(rweight,maxr);
    double1init(qweight,maxq);
    
    if((maxq-1)%4 != 0)
    {
        cout << "maxq-1 not multiple of 4" << endl;
	exit(-1);
    }
    if((maxr-1)%4 != 0)
    {
        cout << "maxr-1 not multiple of 4" << endl;
	exit(-1);
    }
    
    qmesh[1] = 1.e-10;
    for(iq = 2; iq <= maxq; iq++)
    {
        qmesh[iq] = qmesh[iq-1] + qstep;
    }
    
    rmesh[1] = 1.e-10;
    cout << "qmesh = " << qmesh[1] << endl;
    for(ir = 2; ir <= maxr; ir++)
    {
        rmesh[ir] = rmesh[ir-1] + rstep;
    }
    
    mr1 = (maxr-1)/4;
    mq1 = (maxq-1)/4;
    rs  = rstep/22.5;
    qs  = qstep/22.5;
    
    for(ir = 1; ir <= mr1; ir++)
    {
        ir1 = 4*ir+1;
	rweight[ir1] = 14*rs;
	rweight[ir1-1] = 32*rs;
	rweight[ir1-2] = 12*rs;
	rweight[ir1-3] = 32*rs;
	rweight[ir1-4] = 14*rs;
    }
    rweight[1] = 7*rs;
    rweight[maxr] = 7*rs;

    for(iq = 1; iq <= mq1; iq++)
    {
        iq1 = 4*iq+1;
	qweight[iq1] = 14*qs;
	qweight[iq1-1] = 32*qs;
	qweight[iq1-2] = 12*qs;
	qweight[iq1-3] = 32*qs;
	qweight[iq1-4] = 14*qs;
    }
    qweight[1] = 7*qs;
    qweight[maxq] = 7*qs; 
}
   
