#include "common.h"
#include "base.h"
#include "funk.h"


 
static char lniveau(int);
static int lcal(int, int, int);

void qppairout(int j, int parity, char *filen) {




    fstream outfile;
    int chv = 0, iil, ii1, ii2, iit1,iit2;
    int nst, npt;
    int flauf;
    int pr_ok;
    int ib1,ib2,ih1,ih2;
    char isosign[]={'n','p'};    

    outfile.open(filen, ios::out | ios::trunc);

    outfile.precision(5);

    if ((parity%2) == 0)
      outfile << "particle/antiparticle-hole-pairs with J = " << j
	<< " and negative parity" << endl << endl;
    else
      outfile << "particle/antiparticle-hole-pairs with J = " << j
	      << " and positive parity" << endl << endl;
    

    outfile << "parameterset: " << txtfor << endl;
    outfile << "sigma-mass: " << amsig << endl;
    outfile << "coupling constant of sigma: " << gsigs << endl;
    outfile << "omega-mass: " << amome << endl;
    outfile << "coupling constant of omega: " << gomes << endl;
    outfile << "rho-mass: " << amrho << endl;
    outfile << "coupling constant of rho: " << grhos << endl;

    outfile << "maximum energy for particle-hole pairs: "
	  << ediffmaxu << endl;
    outfile << "maximum energy for antiparticle-hole pairs: "
	  << ediffmaxd << endl;

    outfile << endl;
    
    outfile<< "total number of pairs: " << npair  << endl;

    outfile << npair_ph << "/" << npair_ah << 
      " ph-/ah-pairs" << endl;  

    outfile.setf(ios::fixed);


    outfile << "neutronpairs:" << endl << endl;

    int iil_new = 0;
    int iil_ind;
    
    
    for (iil = 1; iil <= npair; iil++) {

    pr_ok = 1;
    iil_ind = iil;
      
    iit1 = iph[iil][3];
    iit2 = iph[iil][4];

    ii1 = iph[iil][1];
    ii2 = iph[iil][2];
    ih1 = indinbl[ii1][iit1];
    ib1 = iblock[ii1][iit1];
    ih2 = indinbl[ii2][iit2];
    ib2 = iblock[ii2][iit2];
	
	if (pr_ok == 1) {
	    outfile << iil_ind << ". pair    en_ok = " << iph[iil][5] << endl;
	  
	    if (ee[ii1][iit1] < -1000.0) 
	    {
		outfile << "E_a = " << " " << ee[ii1][iit1] << " MeV \t";
		outfile <<  "a " << nr[ii1][iit1];
		outfile << lniveau(lcal(nl[ii1][iit1],nj[ii1][iit1],2))
		  << 2*nj[ii1][iit1]-1 << "/" 
		    << 2  << "   " << de[ii1][iit1] << " " << eeqp[ii1][iit1]
		    << "   " <<  h11[ih1][ih1][ib1]
		    << "   " << vv[ii1][iit1] << " " << isosign[iit1-1] << endl;
//add for temperature
//                outfile << "vumark_proton = " << vmark[iil][1] << umark[iil][1] << 
//                    "vumakr_neutron = " << vmark[iil][2] << umark[iil][2] << endl; 
	    }
	    
	    else 
	    {
		outfile << "E_p = " << " " << ee[ii1][iit1] << " MeV \t";
		outfile <<  "p " << nr[ii1][iit1];
		outfile << lniveau(lcal(nl[ii1][iit1],nj[ii1][iit1],1))
		  << 2*nj[ii1][iit1]-1 << "/" 
		    << 2 << "   " << de[ii1][iit1] << "   " << eeqp[ii1][iit1]
		    << "   " <<  h11[ih1][ih1][ib1] 
		    << "   " << vv[ii1][iit1] << " " << isosign[iit1-1] << endl;
	    }
	    
	    outfile << "E_h = " << " " << ee[ii2][iit2] << " MeV \t"; 
	    outfile <<  "h " << nr[ii2][iit2] << lniveau(nl[ii2][iit2]) 
	      << 2*nj[ii2][iit2]-1 << "/" 
		<< 2 << "   " << de[ii2][iit2] << "   " << eeqp[ii2][iit2] 
		<< "   " << h11[ih2][ih2][ib2]  
		<< "   " << vv[ii2][iit2] << " " << isosign[iit2-1] << endl; 
           
           outfile << "Eqp_ini+Eqp_fin = "
		  << " " << eeqp[ii1][iit1]+eeqp[ii2][iit2] << " MeV  "
	          << "H11_ini+H11_fin(diag) = "
		  << h11[ih1][ih1][ib1]+h11[ih2][ih2][ib2]
		  << endl << endl;
//add for temperature
                outfile << "vumark_proton = " << vmark[iil][1] <<"  " << umark[iil][1] <<
                    "vumakr_neutron = " << vmark[iil][2] << "  " << umark[iil][2] << endl;
	}
  }
	
}   




static char lniveau(int nn)
{
    

    char lang[] = {'s','p','d','f','g','h','i','j','\0'};
    char notkn[] = "?";

    if (nn > 7)
      return notkn[0];
    
    else
      return lang[nn];

}

static int lcal(int lc, int jc, int bil)
{
    

    if (bil == 1)
      return lc;
    
    else 
    {
	if (lc < jc)
	  return jc;
	else
	  return (lc-1);
    }
}

    
    
	
	


