#include "common.h"
#include "base.h"
#include "sla.h"
#include "funk.h"
#include "edmonds.h"
#include "prep.h" 



void testint() 
{
    

    
    fstream testfile;


    // variables for test-purposes
    
    double1(tmp);

    double normret = zero;
    double normretneu = zero;    
    double normrenorm = zero;
    double maxerror = zero;
    double temperror = zero;
    double maxerrorneu = zero;
    double temperrorneu = zero;
    
    int index,ir;
    int n, m, l, k;
    int zaehl;
    

    double1init(tmp,2*maxr);
    // just a test for norm of wavefunction

    testfile.open("normtest.out", ios::out | ios::app);

   
    // correcting norm (1: yes, 0:no)
    int correctnorm = 0;
    

// printing common mesh

/*

    for (n = 1; n <= nfe; n++) 
    {
	testfile << "FE Nummer: " << n << endl;
	
	for (m = 1; m <= point[n]; m++)
	{
	    testfile << m << "\t" << rmesh[mapin[n][m]] << endl;
	}
	
	if (n < nfe) 
	{	    
	    testfile << "aeusserer Punkt: " << rmesh[mapex[n]] << endl;
	} 

    }
    

    exit(0);
    
*/
    


    for (n = 1; n <= 2; n++) 
    {
	for (m = 1; m <= ntpar[n]; m++) 
	{
	    normret = zero;
	    zaehl = 0;
	    normretneu = zero;
	   
            tmp[0] = 0;
  
	    for(ir=1; ir <= maxr; ir++)
	    {
	       tmp[ir] = wfg[m][ir][n]*wfg[m][ir][n]+
	                 wfg[m][ir+maxr][n]*wfg[m][ir+maxr][n];
	       tmp[ir] = tmp[ir]*rmesh[ir]*rmesh[ir];
	    }  
             normret = bode(tmp,maxr,rstep);
	   //  normret = simps(tmp,maxr,rstep);
             if (correctnorm == 1)
	    {
					    
		// renormalization of the wavefunctions on the totalmesh

		//cout << "correcting norm on gaussian wavefunctions" << endl;
		
		normrenorm = sqrt(normret);
		
		
		for (l = 1; l <= maxr; l++) 
		{
		    wfg[m][l][n] /= normrenorm;
		    wfg[m][l+maxr][n] /= normrenorm;
		}
	    }   
	    

	    temperror = abs0(one-normret);
	    if (temperror > maxerror)
	      maxerror = temperror;
	    

	}
    }

//    cout << "maximum error with" << 
//      " original normalization in gaussian integration: " 
//	<< maxerror << endl;
    
    testfile << "maximum error with" << 
      " original normalization in bode integration: " 
	<< maxerror << endl;


    if (correctnorm == 1) 
    {
		
	
	// norm-test after renormalization

	maxerror = zero;
	temperror = zero;
    

	for (n = 1; n <= 2; n++) 
	{
	    for (m = 1; m <= ntpar[n]; m++) 
	    {
		normret = zero;
		zaehl = 0;
	    
	        for(ir=1; ir <= maxr; ir++)
	        {
	           tmp[ir] = wfg[m][ir][n]*wfg[m][ir][n]+
	                 wfg[m][ir+maxr][n]*wfg[m][ir+maxr][n];
	           tmp[ir] = tmp[ir]*rmesh[ir+1]*rmesh[ir+1];
	        }  	    

                normret = bode(tmp,maxr,rstep);

		temperror = abs0(one-normret);
		if (temperror > maxerror)
		  maxerror = temperror;
	    

	    }
	}

	cout << "maximum error after corrected normalization " 
	  << "in gaussian integration: " 
	  << maxerror << endl;

	testfile << "maximum error after corrected normalization " 
	  << "in gaussian integration: " 
	  << maxerror << endl;


    }
    

    testfile.close();
    

}
